





OS_CYCLES_TO_NSEC(3P)                                    OS_CYCLES_TO_NSEC(3P)







NAME

     OS_NSEC_TO_CYCLES, OS_USEC_TO_CYCLES, OS_CYCLES_TO_NSEC,

     OS_CYCLES_TO_USEC - convert to, from CPU Count register cycles to

     nanoseconds or microseconds



SYNOPSIS

     #include <ultra64.h>



     OSTime OS_NSEC_TO_CYCLES(u64 nsecs);



     OSTime OS_USEC_TO_CYCLES(u64 usecs);



     u64 OS_CYCLES_TO_NSEC(OSTime cycles);



     u64 OS_CYCLES_TO_USEC(OSTime cycles);





DESCRIPTION

     OS_NSEC_TO_CYCLES and OS_USEC_TO_CYCLES are cpp(1) macros that

     respectively convert from nanoseconds and microseconds to CPU Count

     register cycles.  Conversely, OS_CYCLES_TO_NSEC and OS_CYCLES_TO_USEC are

     macros that respectively convert from CPU Count register cycles to

     nanoseconds and microseconds.



     CPU Count register ticks are the units used by the timer services

     osGetTime(3P) and osSetTimer(3P).  This counter increments at 46.875 Mhz

     and each counter tick represents approximately 21.33 nanoseconds.



     Note that all types are 64 bit quantities, so formatted print functions

     must use the "%ll" size format to print these values correctly.



SEE ALSO

     osGetCount(3P)













































                                                                        Page 1







