





__osGetCurrFaultedThread(3P)                      __osGetCurrFaultedThread(3P)







NAME

     __osGetCurrFaultedThread, __osGetNextFaultedThread - internal routines to

     access faulted thread



SYNOPSIS

     #include <ultra64.h>

     #include <os_internal.h>



     OSThread * __osGetCurrFaultedThread(void);



     OSThread * __osGetNextFaultedThread(OSThread *last);





DESCRIPTION

     The Nintendo64 operating system contains some internal routines to access

     threads that have faulted due to various exceptions such as TLB misses.

     Sine these routines were originally designed for internal use only, their

     names have a "__" prefix notation. Internally, there exists a thread

     queue containing all the active threads created in the system. This queue

     is used mainly by rmon for debugging purpose.



     Currently, when a thread hits a CPU exception such as a TLB exception on

     an instruction fetch, the exception handler saves all the appropriate

     registers to the thread context, stops the thread from execution, marks

     it for the debugger, sends a message to any registered thread waiting for

     the OS_EVENT_FAULT event, and dispatches the next runnable thread from

     the run queue. If rmon is running, it registers to receives the

     OS_EVENT_FAULT event, receives the faulted message, sends the faulted

     thread context to gload running on the host, and causes gload to print

     the thread context (mainly registers) to the screen.  If desired,

     developers can use the routines below in a thread that registers for the

     OS_EVENT_FAULT to handle CPU fault. Please see the sample application

     "fault" on how to use these routines.



     __osGetCurrFaultedThread returns the most recent faulted thread or NULL,

     if there is no faulted thread.



     Based on the last thread, __osGetNextFaultedThread returns the next

     faulted thread from the active thread queue. If last is NULL, this

     routine performs a sequential search from the beginning of the queue.

     Otherwise, it starts the search from the last thread. If no faulted

     thread is found, NULL is returned.



SEE ALSO

     osInitialize(3P), osCreateThread(3P), osStartThread(3P),

     osStopThread(3P), osDestroyThread(3P)



















                                                                        Page 1







