





__osGetTLBASID(3P)                                          __osGetTLBASID(3P)







NAME

     __osGetTLBASID, __osGetTLBPageMask, __osGetTLBHi, __osGetTLBLo0,

     __osGetTLBLo1 - internal routines to access TLB registers



SYNOPSIS

     #include <ultra64.h>

     #include <os_internal.h>



     u32 __osGetTLBASID(void);



     u32 __osGetTLBPageMask(s32 index);



     u32 __osGetTLBHi(s32 index);



     u32 __osGetTLBLo0(s32 index);



     u32 __osGetTLBLo1(s32 index);





DESCRIPTION

     The Nintendo64 operating system contains some internal routines that

     provide access to MIPS R4300 Translation Lookaside Buffer (TLB)

     registers. To reduce potential duplicate effort from developers, these

     routines are described below.  Sine these routines were originally

     designed for internal use only, their names have a "__" prefix notation.

     For more information on the use of the R4300 registers, please refer to

     the MIPS R4300 User's Manual.



     The __osGetTLBASID routine returns the current TLB Address Space ID in

     the R4300 EntryHi register.



     Based on the index, __osGetTLBPageMask reads the appropriate TLB entry

     and returns the value of the R4300 PageMask register.



     Based on the index, __osGetTLBHi reads the appropriate TLB entry and

     returns the value of the R4300 EntryHi register.



     Based on the index, __osGetTLBLo0 reads the appropriate TLB entry and

     returns the value of the R4300 EntryLo0 register.



     Based on the index, __osGetTLBLo1 reads the appropriate TLB entry and

     returns the value of the R4300 EntryLo1 register.



SEE ALSO

     __osGetCause (3P)





















                                                                        Page 1







