





alAudioFrame(3P)                                              alAudioFrame(3P)







NAME

     alAudioFrame - create an audio command list for one frame.





SYNOPSIS

     #include <libaudio.h>



     Acmd    *alAudioFrame(Acmd *cmdList, s32 *cmdLen, s16 *outBuf, s32 outLen);





PARAMETERS

     cmdList   pointer to the location at which to start writing the audio

               command list.



     cmdLen    pointer to the location at which alAudioFrame is to write the

               length of the command list it generates.



     outBuf    pointer to the DRAM location that the audio microcode, when

               executing the audio command list generated by alAudioFrame, is

               to write the synthesized audio samples.



     outLen    the number of stereo samples that the audio command list is to

               generate.



DESCRIPTION

     An audio command list is a sequence of commands or directions that is

     interpreted by the RSP audio microcode describing how audio is to be

     synthesized.  alAudioFrame generates an audio command list that, when

     executed on the RSP, will put a buffer of outLen synthesized stereo

     samples at the DRAM location specified by outBuf. The outBuf should

     contain four bytes for each sample requested by outLen since stereo 16

     bit samples will be generated.  alAudioFrame writes the length, in number

     of rsp commands (each 8 bytes long), of the command list it generates to

     the signed 32 bit value pointed to by cmdLen. It also returns a pointer

     to the next available command list location.



     If there are no players associated with the synthesizer, alAudioFrame

     will set cmdLen to zero and the application should not send the task to

     the RSP.



     Note: alAudioFrame does not actually cause the command list to be

     executed.



























                                                                        Page 1







