





alHeapAlloc(3P)                                                alHeapAlloc(3P)







NAME

     alHeapAlloc - allocate memory from an Ultra 64 audio heap.





SYNOPSIS

     #include <libaudio.h>



     void    *alHeapAlloc(ALHeap *hp, s32 num, s32 size);





PARAMETERS

     hp        pointer to the ALHeap structure.



     num       number of records to allocate.



     size      size, in bytes, of the records to allocate.



DESCRIPTION

     alHeapAlloc allocates cache-aligned memory from an audio DRAM heap. In

     the debug version of libultra (libultra_d), alHeapAlloc also inserts some

     debugging information that allows alHeapCheck to test for heap

     consistency.



     Note: Most memory management schemes allocate additional memory for

     region headers to facilitate the management of the memory region. The

     non-debug version of alHeapAlloc does not allocate any memory other than

     that requested or required for cache alignment. As a result, memory

     allocated from audio heaps cannot be freed.



     Note: Cache alignment is important for structures that contain elements

     shared with the RCP.





SEE ALSO

     alHeapInit(3P), alHeapCheck(3P)









































                                                                        Page 1







