





alHeapInit(3P)                                                  alHeapInit(3P)







NAME

     alHeapInit - initialize an audio heap for use with the Ultra 64 Audio

     Library





SYNOPSIS

     #include <libaudio.h>



     void    alHeapInit(ALHeap *hp, u8 *base, s32 len);





PARAMETERS

     hp        pointer to the ALHeap structure representing the heap to

               initialize



     base      pointer to the start of DRAM heap.



     len       length, in bytes, of the DRAM heap.



DESCRIPTION

     The audio heap functionality provides a way for the application to

     provide memory to the audio library. At initialization time, the

     application passes a pointer to the heap, when making the following

     calls:  alInit(), alSeqpNew(), alCSPNew(), and alSndpNew(). When these

     calls return, they have completed all memory allocation that they will

     need. In addition to using the audio heap for library initialization

     routines, typical applications will use the heap for allocation of

     application controlled buffers.



     The audio heap functionality provides a convenient way to insure that

     buffers are aligned to 16 byte boundaries. This is highly suggested for

     any buffer that is shared between the RSP and the CPU.



     After the audio library is initialized, and the application has allocated

     all the buffers that it needs, the heap structure can be examined to see

     if the amount of space originally allocated for the heap was of the

     appropriate size.



     Note: Memory allocated from audio heaps cannot be freed.





SEE ALSO

     alHeapAlloc(3P), alHeapCheck(3P), alInit(3P), alSeqpNew(3P),

     alCSPNew(3P), alSndpNew(3P)























                                                                        Page 1







