





alSeqPlayer(3P)                                                alSeqPlayer(3P)







NAME

     alSeqPlayer - Ultra 64 MIDI sequence player routines.





SYNOPSIS

     #include <libaudio.h>





     void    alSeqpNew(ALSeqPlayer *seqp, ALSeqpConfig *config);

     void    alSeqpDelete(ALSeqPlayer *seqp);

     void    alSeqpSetSeq(ALSeqPlayer *seqp, ALSeq *seq);

     ALSeq   *alSeqpGetSeq(ALSeqPlayer *seqp);

     void    alSeqpSetBank(ALSeqPlayer *seqp, ALBank *b);

     s32     alSeqpGetState(ALSeqPlayer *seqp);

     void    alSeqpPlay(ALSeqPlayer *seqp);

     void    alSeqpStop(ALSeqPlayer *seqp);

     void    alSeqpSetTempo(ALSeqPlayer *seqp, s32 tempo);

     s32     alSeqpGetTempo(ALSeqPlayer *seqp);

     s16     alSeqpGetVol(ALSeqPlayer *seqp);

     void    alSeqpSetVol(ALSeqPlayer *seqp, s16 vol);



     void    alSeqpSetChlProgram(ALSeqPlayer *seqp, u8 chan, u8 prog);

     s32     alSeqpGetChlProgram(ALSeqPlayer *seqp, u8 chan);

     void    alSeqpSetChlFXMix(ALSeqPlayer *seqp, u8 chan, u8 fxmix);

     u8      alSeqpGetChlFXMix(ALSeqPlayer *seqp, u8 chan);

     void    alSeqpSetChlVol(ALSeqPlayer *seqp, u8 chan, u8 vol);

     u8      alSeqpGetChlVol(ALSeqPlayer *seqp, u8 chan);

     void    alSeqpSetChlPan(ALSeqPlayer *seqp, u8 chan, ALPan pan);

     ALPan   alSeqpGetChlPan(ALSeqPlayer *seqp, u8 chan);

     void    alSeqpSetChlPriority(ALSeqPlayer *seqp, u8 chan, u8 priority);

     u8      alSeqpGetChlPriority(ALSeqPlayer *seqp, u8 chan);



     void    alSeqpSendMidi(ALSeqPlayer *seqp, s32 ticks, u8 status,

                            u8 byte1, u8 byte2);



     void    alSeqpLoop(ALSeqPlayer *seqp, ALSeqMarker *start,

                        ALSeqMarker *end, s32 count);







DESCRIPTION

     The Ultra 64 Audio Library supports playback of MIDI sequences using

     either the Type 0 MIDI Sequence Player, whose routines start with alSeqp,

     or the Compressed MIDI Sequence Player, whose routines start with alCSP.

     This man page details the Type 0 MIDI Sequence Player. For details of the

     Compressed MIDI Sequence Player, see the man page for alCSeqPlayer. The

     principle differences between the two MIDI players are the handling of

     loops, and the compression of data. Details are discussed in the Nintendo

     64 Programming Manual's chapters, Audio Library and Audio Formats.













                                                                        Page 1













alSeqPlayer(3P)                                                alSeqPlayer(3P)







     The sequence player handles the playback of the sequence, but the actual

     sequence data is handled by a Sequence (see alSeq).



     To use the Sequence Player, you must first initialize an ALSeqPlayer

     structure to represent it. This is accomplished with a call to alSeqpNew.



     After initializing the ALSeqPlayer structure, you must set the bank and

     the sequence with calls to alSeqpSetBank and alSeqpSetSeq respectively.



     To start the sequence player playing call alSeqpPlay. To stop the

     sequence player call alSeqpStop. The sequence player can only have one

     target sequence at a time. You must stop a sequence before setting and

     playing a new sequence. You should not attempt to switch banks while a

     sequence is playing. You can use alCSPGetState to determine if the

     sequence player is fully stopped. When you call alSeqpStop, all

     processing of the sequence will stop and all notes will be turned off.



     When a sequence is stopped it will not "rewind" but will remain pointing

     to its current location. This allows you to restart a sequence from where

     it was stopped with a call to alSeqpPlay. Sustained notes that were cut

     off by a call to alSeqpStop will not be restarted, only new notes will be

     processed.



     If you want to rewind the sequence or relocate to another point in the

     sequence, you can create an ALSeqMarker at the desired location using the

     call alSeqNewMarker, and then call alSeqSetLoc to rewind or relocate the

     sequence.  Note that these calls do not affect the channel playback state

     so care should be taken to make sure that the channel parameters (eg.

     program, vol, pan, etc.) are set to appropriate values for the given

     sequence location.



     Channel parameters can be set with their individual calls or by sending

     the appropriate midi data using alSeqpSendMidi. Music can be created in

     realtime and played back with alSeqpSendMidi.



     A single loop can be created by calling alSeqpLoop. You must first create

     and set a begining and end loop. Looping of individual tracks is not

     supported by the sequence player. (For more involved looping see the

     compressed MIDI sequence player. alCSeqPlayer)









SEE ALSO

     alSeq(3P), alSeqpNew(3P), alSeqpDelete(3P), alSeqpSetSeq(3P),

     alSeqpGetSeq(3P), alSeqpPlay(3P), alSeqpStop(3P), alSeqpSetBank(3P),

     alSeqpSetTempo(3P), alSeqpGetTempo(3P), alSeqpGetVol(3P),

     alSeqpSetVol(3P), alSeqpSetChlProgram(3P), alSeqpGetChlProgram(3P),

     alSeqpSetChlFXMix(3P), alSeqpGetChlFXMix(3P), alSeqpSetChlPan(3P),

     alSeqpGetChlPan(3P), alSeqpSetChlVol(3P), alSeqpGetChlVol(3P),

     alSeqpSetChlPriority(3P), alSeqpGetChlPriority(3P), alSeqpSendMidi(3P)









                                                                        Page 2













alSeqPlayer(3P)                                                alSeqPlayer(3P)















































































































                                                                        Page 3













