





alSeqpLoop(3P)                                                  alSeqpLoop(3P)







NAME

     alSeqpLoop - sets sequence loop points





SYNOPSIS

     #include <libaudio.h>



     void alSeqpLoop(ALSeqPlayer *seqp, ALSeqMarker *start, ALSeqMarker *end,

                     int count);





PARAMETERS

     seqp      pointer to the sequence player.



     start     loop start marker.



     end       loop end marker.



     count     number of times to loop. A value of -1 means loop forever.



DESCRIPTION

     alSeqpLoop sets sequence loop points to the locations specified by the

     start and end markers.  These markers must have been previously

     initialized with alSeqNewMarker.



     In order to use loops effectively, several important points concerning

     the behavior of loops and markers must be understood.  Firstly, markers

     always get positioned at sequence event locations, so if you create a new

     marker at a tick location that does not correspond to a sequence event,

     alSeqNewMarker will "snap" the marker to the event previous to the tick

     time.  Secondly, loops are inclusive of the start marker's event and

     exclusive of the end marker's event. That is, the loop is defined as

     [start, end).  Thirdly, loops should always contain an equal number of

     note on and note off events.  This is very important since if the end

     marker is positioned on a note off event it will not be part of the loop

     and the corresponding note on's voice will never get released.  So each

     time through the loop a voice will get used up until the maximum number

     of allocated voices has been reached.  Therefore, be very careful to

     place the end marker so that all note ons are matched with a note off,

     even if this means placing a dummy event at the end loop marker.



     Overall, alSeqpLoop is intended for looping over the entire sequence or

     over well-defined sections of a sequence.  For more comprehensive loops

     that are on a track by track basis, see the compact sequence player which

     embeds loop points in the sequence stream.



WARNING

     The loop markers must remain allocated for the entire duration of the

     loop since the sequence player stores references to these markers.













                                                                        Page 1













alSeqpLoop(3P)                                                  alSeqpLoop(3P)







SEE ALSO

     alSeqNewMarker(3P)











































































































                                                                        Page 2







