





alSeqpNew(3P)                                                    alSeqpNew(3P)







NAME

     alSeqpNew - initialize a Type 0 MIDI sequence player.





SYNOPSIS

     #include <libaudio.h>



     void alSeqpNew(ALSeqPlayer *seqp, ALSeqpConfig *config);





PARAMETERS

     seqp      pointer to the Type 0 MIDI sequence player structure to

               initialize.



     config    pointer to the sequence player configuration structure.





DESCRIPTION

     alSeqpNew initializes a Type ) MIDI sequence player, seqp, for the

     configuration specified in config and signs into the synthesis driver as

     a client.  Note that it allocates memory from the (initialized) ALHeap

     referenced by the config structure.



     The parameters in the ALSeqpConfig structure, config, determine how many

     resources are allocated from the heap. This structure is defined in

     <libaudio.h> The values are as follows:



     maxVoices      the maximum number of voices to support.



     maxEvents      the maximum number of internal events to support.



     maxChannels    the maximum number of MIDI channels to support, usually

                    16, but can be less.



     debugFlags     flags used to turn on and off the reporting of common

                    audio errors. Set to zero to turn off reporting of errors.

                    Turn on error reporting by or'ing together the following

                    values:  NO_SOUND_ERR_MASK controls error messages that

                    occur when there is no sound that covers the requested

                    sound at the specified pitch.  NOTE_OFF_ERR_MASK controls

                    error messages that occur when a note off occurs, but

                    there is no voice currently playing that note on the

                    specified channel.  NO_VOICE_ERR_MASK controls error

                    messages that occur when there are no more voices

                    available to satisfy the request to allocate a voice.



     *initOsc       must point to the procedure that handles the

                    initialization of oscillators used to perform vibrato and

                    tremelo. If vibrato and tremelo are not used, this value

                    must be set to zero.











                                                                        Page 1













alSeqpNew(3P)                                                    alSeqpNew(3P)







     *updateOsc     must point to the procedure that handles the updating of

                    oscillators used to perform vibrato and tremelo. If

                    vibrato and tremelo are not used, this value must be set

                    to zero.



     *stopOsc       must point to the procedure that handles the shutting down

                    of oscillators used to perform vibrato and tremelo. If

                    vibrato and tremelo are not used, this value must be set

                    to zero.



     heap           a pointer to an initialized audio heap.





     An example of setting up and using oscillators is given in the demo

     application Playseq



SEE ALSO

     alHeapNew(3P), alHeapAlloc(3P), alSeqpDelete(3P), alSeqPlayer(3P)











































































                                                                        Page 2







