





alSeqpSendMidi(3P)                                          alSeqpSendMidi(3P)







NAME

     alSeqpSendMidi - sends the given MIDI message to the sequence player.





SYNOPSIS

     #include <libaudio.h>



     void    alSeqpSendMidi(ALSeqPlayer *seqp, long ticks, u8 status,

                            u8 byte1, u8 byte2);





PARAMETERS

     seqp      pointer to sequence player.



     ticks     time offset, in MIDI clock ticks that the MIDI event is to

               occur.



     status    the message's MIDI status byte.



     byte1     the first byte in the message.



     byte2     the second byte in the message (if required).



DESCRIPTION

     alSeqpSendMidi sends a MIDI message to the sequence player. This can be

     used to trigger notes not in the sequence, add controller information in

     realtime, or otherwise change the performance of a sequence.

     alSeqpSendMidi can be used as an alternative for alSeqpSetChlProgram,

     alSeqpSetChlVol, alSeqpSetChlPan, and alSeqpSetChlFXMix.



     Note that only channel voice messages are supported. See the MIDI 1.0

     specification or any of the various World Wide Web MIDI pages for more

     information.



     The ticks field contains the time offset (in MIDI clock ticks) at which

     the event is to occur. The status byte contains the message type in the

     high nibble and the channel number in the low nibble. The next bytes are

     the MIDI data, which is determined by the message type.





SEE ALSO























                                                                        Page 1













