





alSynNew(3P)                                                      alSynNew(3P)







NAME

     alSynNew - allocate the specified synthesizer driver.





SYNOPSIS

     #include <libaudio.h>



     void alSynNew(ALSynth *drvr, ALSynConfig *c);





PARAMETERS

     drvr      pointer to the synthesizer driver.



     c         pointer to the synthesizer configuration.



DESCRIPTION

     Initialize the synthesizer driver structure pointed to by drvr, using

     parameters specified in the configuration structure. alSynNew will

     allocate memory from the heap for voices and driver objects. alSynNew

     should always be called before any call to alAudioFrame. The parameters

     of the configuration structure are as follows:



     maxVVoices     maximum number of virtual voices.



     maxPVoices     maximum number of physical voices.



     maxUpdates     maximum number of pending parameter updates.



     maxFXBusses    maximum number of auxiliary effect busses. (Currently this

                    value is ignored, and a maximum of one bus is imposed.)



     dmaproc        pointer to procedure to use when initializing DMA

                    callbacks.



     heap           pointer to audio system memory heap.



     outputRate     numbers of samples per second for synthesizer to generate.



     fxType         type of effect to use, can be AL_FX_NONE, AL_FX_SMALLROOM,

                    AL_FX_BIGROOM, AL_FX_ECHO, AL_FX_CHORUS, AL_FX_FLANGE,

                    AL_FX_CUSTOM.



     params         Pointer to an array of parameters, to be used in the case

                    of AL_FX_CUSTOM. For more information on these parameters

                    refer to the Ultra 64 programming manual's audio section

                    detailing creation of custom effects.





SEE ALSO

     alSynDelete(3P)











                                                                        Page 1













alSynNew(3P)                                                      alSynNew(3P)















































































































                                                                        Page 2













