





alSynSetPitch(3P)                                            alSynSetPitch(3P)







NAME

     alSynSetPitch - set the pitch of the specified voice.





SYNOPSIS

     #include <libaudio.h>



     void alSynSetPitch(ALSynth *drvr, ALVoice *voice, float pitch);





PARAMETERS

     drvr      pointer to the synthesizer driver.



     voice     pointer to a voice.



     pitch     the pitch value.



DESCRIPTION

     Sets the rate at which a wavetable will be "rendered" by the synthesizer.

     pitch can range from 0 < pitch < 2.0. If the sample rate of the wavetable

     is the same as the output rate set by osAiSetFrequency a value of 1.0

     will play the sound with no pitch change, a value of 0.5 will play the

     sound pitch shifted down an octave, and a value of 2.0 will play the

     pitch shifted up one octave. Negative pitch values are undefined. Care

     should be taken to insure that a pitch value of zero is never used, since

     it will cause a divide by zero. Values greater than 2.0 will be clamped

     to 2.0.



WARNING

     alSynSetPitch should only be called from within an ALVoiceHandler.





SEE ALSO

     alSynSetVol(3P), alSynSetPan(3P), alSynSetFXMix(3P),

     alSynStartVoiceParam(3P), osAiSetFrequency(3P)









































                                                                        Page 1







