





alSynStartVoice(3P)                                        alSynStartVoice(3P)







NAME

     alSynStartVoice - start synthesizing audio samples with the specified

     voice.





SYNOPSIS

     #include <libaudio.h>



     void alSynStartVoice(ALSynth *drvr, ALVoice *voice, ALWaveTable *table);





PARAMETERS

     drvr      pointer to the synthesizer driver.



     voice     pointer to a voice.



     table     pointer to a sound wavetable.



DESCRIPTION

     Begin generating entries into the command lists created by alAudioFrame,

     to synthesize audio samples for the given voice from sample data in the

     wavetable pointed to by table. Before calling alSynStartVoice, the voice

     must be allocated from the driver with a call to alSynAllocVoice. Since

     alSynAllocVoice isn't always successful, be sure to check the result

     before calling alSynStartVoice. Before starting a voice, the pitch, pan,

     fxmix, and volume should be set. Alternatively, alSynStartVoiceParam may

     be used. When the voice is no longer sounding, alSynStopVoice may be

     called, and then alSynFreeVoice.



WARNING

     The synthesis driver expects that the loop data and adpcm book data (if

     compressed wavetable) are located in DRAM.  The actual wavetable data can

     be located in ROM and later DMA'd into DRAM, but the loop and book data

     are accessed before the DMA occurs.  This is important when writing a

     custom bank file.



     When writing a custom player, alSynStartVoice should only be called from

     within an ALVoiceHandler. Also, do not set any of the voice's parameters

     (eg. alSynSetVol) if the voice is in the stopped state, unless the voice

     is started in the same audio frame. In other words, if a call is made to

     set a stopped voice's parameters and the voice is not started until one

     or more frames later, then unexpected results will occur.



SEE ALSO

     alSynAllocVoice(3P), alSynStopVoice(3P), alSynFreeVoice(3P),

     alSynSetPitch(3P), alSynSetPan(3P), alSynSetVol(3P), alSynSetFXMix(3P),

     alSynStartVoiceParam(3P), alAudioFrame(3p)

















                                                                        Page 1







