





alSynStartVoiceParam(3P)                              alSynStartVoiceParam(3P)







NAME

     alSynStartVoiceParam - start synthesizing audio samples with the

     specified voice using the specified parameters.





SYNOPSIS

     #include <libaudio.h>



     void alSynStartVoiceParam(ALSynth *drvr, ALVoice *voice, ALWaveTable *tbl,

     f32 pitch, s16 vol, ALPan pan, u8 fxmix, ALMicroTime time);





PARAMETERS

     drvr      pointer to the synthesizer driver.



     voice     pointer to a voice.



     tbl       pointer to a sound wavetable.



     pitch     float value describing the pitch ratio.



     vol       volume to use for playback.



     pan       stereo pan to use for playback.



     fxmix     relative mix of effect processed signal to unprocessed signal.



     time      time in Microseconds for the sound to reach the specified

               volume level.



DESCRIPTION

     Begin generating entries into the command lists created by alAudioFrame,

     to synthesize audio samples for the given voice from sample data in the

     wavetable pointed to by table. using the parameters specifed. Before

     calling alSynStartVoiceParam, the voice must be allocated from the driver

     with a call to alSynAllocVoice. Since alSynAllocVoice isn't always

     successful, be sure to check the result before calling

     alSynStartVoiceParam. Valid values for pitch, pan, fxmix, and volume are

     detailed in man pages alSynSetPitch, alSynSetPan, alSynSetFXMix and

     alSynSetVol. When the voice has finished sounding, alSynStopVoice may be

     called, and then alSynFreeVoice.



WARNING

     The synthesis driver expects that the loop data and adpcm book data (if

     compressed wavetable) are located in DRAM.  The actual wavetable data can

     be located in ROM and later DMA'd into DRAM, but the loop and book data

     are accessed before the DMA occurs.  This is important when writing a

     custom bank file.



     When writing a custom player, alSynStartVoiceParam should only be called

     from within an ALVoiceHandler. Also, do not set any of the voice's

     parameters (eg. alSynSetVol) if the voice is in the stopped state, unless







                                                                        Page 1













alSynStartVoiceParam(3P)                              alSynStartVoiceParam(3P)







     the voice is started in the same audio frame. In other words, if a call

     is made to set a stopped voice's parameters and the voice is not started

     until one or more frames later, then unexpected results will occur.



SEE ALSO

     alSynAllocVoice(3P), alSynStopVoice(3P), alSynFreeVoice(3P),

     alSynSetPitch(3P), alSynSetPan(3P), alSynSetVol(3P), alSynSetFXMix(3P),

     alSynStartVoice(3P), alAudioFrame(3p)































































































                                                                        Page 2







