





gDPLoadTLUT_pal(3P)                                        gDPLoadTLUT_pal(3P)







NAME

     gDPLoadTLUT_pal16, gsDPLoadTLUT_pal16, gDPLoadTLUT_pal256,

     gsDPLoadTLUT_pal256 - load a texture look-up table into texture memory



C SPECIFICATION

     #include "gbi.h"



     gDPLoadTLUT_pal16(Gfx *gdl, unsigned int pal, unsigned int dram)



     gsDPLoadTLUT_pal16(unsigned int pal, unsigned int dram)



     gDPLoadTLUT_pal256(Gfx *gdl, unsigned int dram)



     gsDPLoadTLUT_pal256(unsigned int dram)





PARAMETERS

     *gdl      graphics display list pointer.



     pal       Load the texture lookup table into one of sixteen palettes.

               Only for 4 bit color indexed textures.



     dram      Address of look-up table in RAM.  Must be 64 bit aligned.



DESCRIPTION

     A portion of the texture memory can be used for storing texture lookup

     tables.  The TLUT is located in the upper 256 words of Tmem. Therefore,

     color index textures are always loaded in the low 256 words of Tmem.  The

     type of texels in the TLUT can be either 16-bit RGBA or 16-bit IA.  For

     256-entry palettes, the entire upper half of Tmem is used.  For 16-entry

     palettes, the location in the upper half of Tmem depends on the palette

     number. 16-entry Palette numbers can range from 0 to 15.  A more detailed

     description is given in the "RDP State Machine" and "Texture" chapters of

     the NU64 Programming Manual.



SEE ALSO

     gDPLoadTextureBlock(3P), gDPLoadTextureTile(3P)





































                                                                        Page 1







