





gDPSetAlphaCompare(3P)                                  gDPSetAlphaCompare(3P)







NAME

     gDPSetAlphaCompare, gsDPSetAlphaCompare - set alpha compare mode for

     conditional write to framebuffer.



C SPECIFICATION

     #include "gbi.h"



     gDPSetAlphaCompare(Gfx *gdl, unsigned int mode)



     gsDPSetAlphaCompare(unsigned int mode)







PARAMETERS

     *gdl      graphics display list pointer.



     mode      G_AC_NONE, G_AC_THRESHOLD, G_AC_DITHER.



DESCRIPTION

     G_AC_NONE mode will disable alpha compare checking.



     G_AC_THRESHOLD mode will conditionally update the framebuffer if the

     pipeline pixel alpha is greater than the blend color alpha.  This is

     typically used to cut out transparent regions of a texture map to give

     complex outlined objects.  This is more efficient than rendering

     translucent surfaces and writing the actual transparent regions.



     G_AC_DITHER mode will conditionally update the framebuffer if the

     pipeline pixel alpha is greater than a random dither value.  Using this

     with an alpha gradient on a surface can give a nice particle fade out

     result.



     You should use the Render Mode G_RM_TEX_EDGE when enabling alpha compare

     in G_CYC_1CYCLE or G_CYC_2CYCLE pipeline mode.  This is because you must

     get the alpha of the pixel on the coverage path in order for the compare

     to work and this mode prevents reading of the color framebuffer.



     G_AC_THRESHOLD and G_AC_DITHER modes can also be used when the pipeline

     is in G_CYC_COPY mode. Because normal alpha blending is disabled in copy

     mode, this is the only way to achieve transparency in copy mode.  For

     16-bit RGBA (5/5/5/1) frame buffers, the alpha bit acts as a write

     enable, i.e. no compare with the blend alpha is performed.  For 8-bit CI

     frame buffers, the blend alpha compare is enabled.  Copy mode can not be

     used for 32-bit RGBA framebuffers.



NOTE

     If using antialiasing rendering modes, G_AC_THRESHOLD can only threshhold

     against blend color alpha=0.















                                                                        Page 1













gDPSetAlphaCompare(3P)                                  gDPSetAlphaCompare(3P)







SEE ALSO

     gDPSetBlendColor(3P)











































































































                                                                        Page 2







