





gDPSetAlphaDither(3P)                                    gDPSetAlphaDither(3P)







NAME

     gDPSetAlphaDither, gsDPSetAlphaDither - enable or disable alpha dithering



C SPECIFICATION

     #include "gbi.h"



     gDPSetAlphaDither(Gfx *gdl, unsigned int type)



     gsDPSetAlphaDither(unsigned int type)







PARAMETERS

     *gdl      graphics display list pointer.



     type      choose type of alpha dithering, either G_AD_PATTERN,

               G_AD_NOTPATTERN, G_AD_NOISE, or G_AD_DISABLE.



DESCRIPTION

     This command selects (or disables) various types of alpha dithering. The

     RDP pipeline keeps alpha values in 8 bit precision until the Blender.

     The blender processes alpha in only 5 bits of precision.  Therefore,

     dither may be necessary in order to remove Mach bands.  However, the

     alpha channel is typically used for transparency and the transparency

     coefficient Mach bands are much less noticible.



     The various types of dither patterns all have their strengths and

     weaknesses, depending on other rendering modes and content of the scene.

     Choosing a noise dither may give a special noisy effect while pattern

     dither typically yields better results when camara motion movement is

     slow.



     G_AD_PATTERN, alpha dither depends on setting of color dither.  If the

     color dither is disabled, the "standard" Bayer matrix order dither is

     used for alpha dithering.  If the color dither is noise dither, a magic

     square order dither is used for alpha dithering.  Note that even if you

     use a 32 bit framebuffer where color dithering is not necessary, alpha

     will always reduce from 8 to 5 bits in the blender.



     G_AD_NOTPATTERN, inverted pattern of what G_AD_PATTERN is.



     G_AD_NOISE, random noise dither.



     G_AD_DISABLE, no dithering.



SEE ALSO

     gDPSetAlphaCompare(3P) gDPSetColorDither(3P)

















                                                                        Page 1







