





gDPSetColorDither(3P)                                    gDPSetColorDither(3P)







NAME

     gDPSetColorDither, gsDPSetColorDither - enable or disable RGB color

     dithering



C SPECIFICATION

     #include "gbi.h"



     gDPSetColorDither(Gfx *gdl, unsigned int type)



     gsDPSetColorDither(unsigned int type)







PARAMETERS

     *gdl      graphics display list pointer.



     type      choose type of color dithering, either G_CD_MAGICSQ,

               G_CD_BAYER, G_CD_NOISE, G_CD_ENABLE, or G_CD_DISABLE.



DESCRIPTION

     This command selects (or disables) various types of color dithering.  The

     RDP pipeline keeps individual color component values in 8 bit precision

     until the Memory Interface.  The framebuffer can only accept color

     components in 5 bit precision when using 16 bit per pixel framebuffer

     format.  Therefore, dithering may be necessary to remove Mach bands.



     Ordered dither has the effect of "scattering" the original complete

     information into a pixel neighborhood region.  The video interface (VI)

     contains logic to "gather" or recover the original information within the

     pixel neighborhood during video display; this feature can be enabled or

     disabled by calling osViSetSpecialFeatures (3P) with either

     OS_VI_DITHER_FILTER_ON or OS_VI_DITHER_FILTER_OFF, respectively.  This

     yields the best results in removing Mach bands in the low color

     resolution format (5/5/5 RGB).



     G_CD_MAGICSQ an ordered pattern dither, the preferred choice if the video

     dither filtering is enabled.



     G_CD_BAYER, an ordered pattern dither - the "standard" Bayer matrix, the

     preferred choice if the video dither filtering is disabled.



     G_CD_NOISE, random noise dither.



     G_CD_DISABLE, no dithering.



     G_CD_ENABLE, enable random noise dither.  This is for Hardware 1

     compatiblity only.  For Hardware 2, please use G_CD_MAGICSQ, G_CD_BAYER,

     G_CD_NOISE, or G_CD_DISABLE.















                                                                        Page 1













gDPSetColorDither(3P)                                    gDPSetColorDither(3P)







SEE ALSO

     gDPSetAlphaDither(3P), osViSetSpecialFeatures(3P)











































































































                                                                        Page 2







