





gDPSetCombineMode(3P)                                    gDPSetCombineMode(3P)







NAME

     gDPSetCombineMode, gsDPSetCombineMode - commonly used color combiner

     modes



C SPECIFICATION

     #include "gbi.h"



     gDPSetCombineMode(Gfx *gdl, int mode1, int mode2)



     gsDPSetCombineMode(int mode1, int mode2)





PARAMETERS

     *gdl      graphics display list pointer.



     mode1, mode2

               Common color combiner modes selection.  In one cycle

               configuration, mode1 and mode2 should be set to the same mode.

               In two cycle configuration, mode1 specifies how to combine in

               cycle1.  Mode2 specifies how to combine in cycle2.



DESCRIPTION

     This command is used to set commonly used color combine modes.  An

     example typical color combine operation is to modulate texture color with

     shade color.



     The following is a list of available modes for one cycle configuration.

     Both the mode1 and mode2 parameters should be set to the same value when

     in one cycle mode.



     G_CC_PRIMITIVE

          Use the CC primitive color as output.



     G_CC_SHADE

          Use the pipeline shading color as output.



     G_CC_MODULATEI

          Intensity texture modulate shade color for RGB.  Shade alpha is not

          modulated.



     G_CC_MODULATEIA

          Intensity texture modulate shade color for RGBA.



     G_CC_MODULATEIDECALA

          Intensity texture modulate shade color for RGB.  Texture alpha is

          the output alpha.



     G_CC_MODULATERGB

          RGB texture modulate shade color for RGB.  Shade alpha is not

          modulated.











                                                                        Page 1













gDPSetCombineMode(3P)                                    gDPSetCombineMode(3P)







     G_CC_MODULATERGBA

          RGB texture modulate shade color for RGBA.



     G_CC_MODULATERGBDECALA

          RGB texture modulate shade color for RGB.  Texture alpha is the

          output alpha.



     G_CC_MODULATEI_PRIM

          Intensity texture modulate primitive color for RGB.  Primitive alpha

          is not modulated.



     G_CC_MODULATEIA_PRIM

          Intensity texture modulate primitive color for RGBA.



     G_CC_MODULATEIDECALA_PRIM

          Intensity texture modulate primitive color for RGB.  Texture alpha

          is the output alpha.



     G_CC_MODULATERGB_PRIM

          RGB texture modulate primitive color for RGB.  Primitive alpha is

          not modulated.



     G_CC_MODULATERGBA_PRIM

          RGB texture modulate primitive color for RGBA.



     G_CC_MODULATERGBDECALA_PRIM

          RGB texture modulate primitive color for RGB.  Texture alpha is the

          output alpha.



     G_CC_DECALRGB

          Texture RGB is the output RGB.  Shade alpha is the output alpha.



     G_CC_DECALRGBA

          Texture RGBA is the output RGBA.



     G_CC_BLENDI

          Intensity texture determines modulation between environment and

          shade RGB.  Shade alpha is the output alpha.



     G_CC_BLENDIA

          Intensity texture determines modulation between environment and

          shade RGBA.



     G_CC_BLENDIDECALA

          Intensity texture determines modulation between environment and

          shade RGB.  Texture alpha is the output alpha.



     G_CC_BLENDRGBA

          Texture alpha determines modulation between texture and shade RGB.

          Shade alpha is the output alpha.











                                                                        Page 2













gDPSetCombineMode(3P)                                    gDPSetCombineMode(3P)







     G_CC_BLENDRGBDECALA

          Texture alpha determines modulation between texture and shade RGB.

          Texture alpha is the output alpha.



     G_CC_HILITERGB

          Texture determines modulation between primitive and shade RGB.

          Shade alpha is the output alpha.



     G_CC_HILITERGBA

          Texture determines modulation between primitive and shade RGBA.



     The following is a list of possible cycle one modes of a two cycle

     configuration.



     G_CC_TRILERP

          Texels from the two bilerp tiles are combined using LOD fraction.



     G_CC_INTERFERENCE

          Texels from the two bilerp tiles are combined together.  If there

          are different frequency bands in the two texture tiles, sliding s

          and t coordinates can give interesting interference patterns.



     G_CC_BLENDPE

          This mode is intended to be used with an intensity (I) texture.  It

          uses the intensity to interpolate between the environment color

          (gDPSetEnvColor (3P)) and primitive color (gDPSetPrimColor (3P)).



     G_CC_BLENDPEDECALA

          This mode is like G_CC_BLENDPE, except it uses the texture only as

          the alpha source.



     The following is a list of possible cycle two modes of a two cycle

     configuration.  Most are the same as their mode1 counterparts.  However,

     since these are for mode2, rather than using RDP pipeline shade RGBA, the

     resultant combined RGBA from mode1 is used.



     G_CC_PASS2

          Pass the RGBA result of the first cycle computation to the output.



     G_CC_MODULATEI2



     G_CC_MODULATEIA2



     G_CC_MODULATERGB2



     G_CC_MODULATERGBA2



     G_CC_MODULATEI_PRIM2



     G_CC_MODULATEIA_PRIM2











                                                                        Page 3













gDPSetCombineMode(3P)                                    gDPSetCombineMode(3P)







     G_CC_MODULATERGB_PRIM2



     G_CC_MODULATERGBA_PRIM2



     G_CC_DECALRGB2



     G_CC_BLENDI2



     G_CC_BLENDIA2



     G_CC_HILITERGB2



     G_CC_HILITERGBA2



SEE ALSO

     gDPSetCycleType(3P) gDPSetTextureLOD(3P) gDPSetPrimColor(3P)

     gDPSetEnvColor(3P)













































































                                                                        Page 4







