





gDPSetImage(3P)                                                gDPSetImage(3P)







NAME

     gDPSetImage, gDPSetColorImage, gsDPSetColorImage, gDPSetDepthImage,

     gsDPSetDepthImage, gDPSetTextureImage, gsDPSetTextureImage - set color,

     depth, texture image buffer area.



C SPECIFICATION

     #include "gbi.h"



     gDPSetColorImage(Gfx *gdl, int fmt, int siz, int width, int img)



     gsDPSetColorImage(int fmt, int siz, int width, int img)



     gDPSetDepthImage(Gfx *gdl, int img)



     gsDPSetDepthImage(int img)



     gDPSetTextureImage(Gfx *gdl, int fmt, int siz, int width, int img)



     gsDPSetTextureImage(int fmt, int siz, int width, int img)







PARAMETERS

     *gdl      graphics display list pointer.



     fmt       image format.  G_IM_FMT_RGBA, G_IM_FMT_YUV, G_IM_FMT_CI,

               G_IM_FMT_IA, G_IM_FMT_I.



     siz       pixel element size.  G_IM_SIZ_4b, G_IM_SIZ_8b, G_IM_SIZ_16b,

               G_IM_SIZ_32b



     width     image width in number of pixel elements.



     img       image pointer.



DESCRIPTION

     G_IM_FMT_RGBA

                 RGBA format.  Red is always packed toward the MSB.



     G_IM_FMT_YUV

                 YUV format.



     G_IM_FMT_CI Color indexed format.



     G_IM_FMT_IA Intensity and Alpha format.



     G_IM_FMT_I  Intensity format.



     G_IM_SIZ_4b 4 bits per pixel element.  Only for G_IM_FMT_I













                                                                        Page 1













gDPSetImage(3P)                                                gDPSetImage(3P)







     G_IM_SIZ_8b 8 bits per pixel element.  For G_IM_FMT_CI, G_IM_FMT_I, and

                 G_IM_FMT_IA (4b each component).



     G_IM_SIZ_16b

                 For G_IM_FMT_RGBA (5/5/5/1), G_IM_FMT_MASK, G_IM_FMT_IA (8b

                 each component).



     G_IM_SIZ_32b



     These commands set the framebuffer area for color, depth, and texture

     images.  An application typically has 2 color frame buffers for double

     buffering, which are swapped during the vertical retrace interval.



     If z-buffering is enabled, the application should use the

     gDPSetDepthImage (3P) command to set up the z-buffer area.  The width

     parameter is not needed for gDPSetDepthImage (3P) because the RDP assumes

     the width is the same as the color buffer.  The siz parameter is not

     needed for gDPSetDepthImage (3P) because the depth-buffer is always

     G_IM_SIZ_16b.



     The gDPSetTextureImage (3P) command is used to point to different

     textures.  This command is usually not used directly, it is embedded in

     the gDPLoadTexture* (3P) commands.



     The gDPSetDepthImage (3P) and gDPSetColorImage (3P) commands require a 64

     BYTE aligned address.



SEE ALSO

     gDPSetDepthImage(3P) gDPSetTextureImage(3P) gDPSetColorImage(3P)





















































                                                                        Page 2







