





gDPSetPrimDepth(3P)                                        gDPSetPrimDepth(3P)







NAME

     gDPSetPrimDepth, gsDPSetPrimDepth - set primitive depth (z) in the RDP.



C SPECIFICATION

     #include "gbi.h"



     gDPSetPrimDepth(Gfx *gdl, int z, int dz)



     gsDPSetPrimDepth(int z, int dz)







PARAMETERS

     *gdl      graphics display list pointer.



     z         z value.



     dz        delta z value.





DESCRIPTION

     This command sets the depth (and delta z) to be used for the entire

     primitive in the RDP.  The Z format used in the blender is a 0,15.3 fixed

     point number.  The primitive Z is a 16 bit register.  If the depth source

     is set to G_ZS_PRIM, the top bit is ignored and the remaining 15 bits of

     the primitive Z register provide the 15 integer bits for the Z value.

     When using primitive Z, the fractional bits will be zero.  The delta Z

     format used in the blender is a 16 bit number.  The primitive delta Z can

     provide all 16 bits.



     Note that the Z value is converted to a 14 bit quantity and the delta Z

     value is converted to a 4 bit quantity for storage into the Z buffer.

     For details on how the Z values are used and stored, please see NU64

     Programming Manual.



SEE ALSO

     gDPSetPrimColor(3P) gDPSetDepthSource(3P)





































                                                                        Page 1







