





gDPSync(3P)                                                        gDPSync(3P)







NAME

     gDPSync, gDPPipeSync, gsDPPipeSync, gDPFullSync, gsDPFullSync,

     gDPLoadSync, gsDPLoadSync, gDPTileSync, gsDPTileSync - synchronizes RDP

     attribute updates with primitive rendering.



C SPECIFICATION

     #include "gbi.h"



     gDPPipeSync(Gfx *gdl)



     gsDPPipeSync(void)



     gDPFullSync(Gfx *gdl)



     gsDPFullSync(void)



     gDPLoadSync(Gfx *gdl)



     gsDPLoadSync(void)



     gDPTileSync(Gfx *gdl)



     gsDPTileSync(void)







PARAMETERS

     *gdl      graphics display list pointer.



DESCRIPTION

     Pixel rendering and attribute interpolation are not implicitly

     sequentially sychronized in the RDP.  If an attribute change occurs after

     a primitive has started processing, the attribute change will likely

     affect the rendered pixels in the middle of the primitive.  These

     commands allow the application to insert explicit syncronization

     instructions to force a wait until the last pixel of a primitive has been

     processed.



     The different sync types represent different synchronization scenarios.

     gDPPipeSync synchronizes the attribute interpolation pipe, gDPLoadSync

     synchronizes texture loads, and gDPTileSync synchronizes texture tile

     settings.  gDPFullSync is a special case, signaling the end of a frame.



     The general rule is that a gDPPipeSync(3P) command must be inserted after

     a (group of) primitives but before an RDP attribute change command.



        gSP1Triangle(...);

        gSP1Triangle(...);

        gSP1Triangle(...);

        gDPPipeSync(...);

        gDPSetRenderMode(...);

99





                                                                        Page 1













gDPSync(3P)                                                        gDPSync(3P)







     The last command sent to the RDP during a frame must be a gDPFullSync(3P)

     command.  This command causes the RDP to send an interrupt back to the

     CPU indicating that the RDP pipeline has finished processing its last

     command.



     Load and Tile Syncs are not normally needed; they are already properly

     inserted in the gDPLoadTexture* command macros.



SEE ALSO

     gDPLoadTexture*(3P)



























































































                                                                        Page 2







