





gSPForceMatrix(3P)                                          gSPForceMatrix(3P)







NAME

     gSPForceMatrix, gsSPForceMatrix - Load a new matrix without

     multiplications.



C SPECIFICATION

     #include "gbi.h"



     gSPForceMatrix(Gfx *gdl, Mtx *mptr)



     gsSPForceMatrix(Mtx *mptr)





PARAMETERS

     *gdl      graphics display list pointer.



     mptr      pointer to the matrix to load (see note below about format).



DESCRIPTION

     This is an advanced command.  A good understanding of how matrices work

     in the RSP microcode is suggested before using this command (see

     gSPMatrix (3P)).



     This command will load a new matrix (pointed to by mptr) into the top of

     the RSP's matrix stacks.  It bypasses any matrix multiplication and

     replaces the concatenated MODELVIEW and PROJECTION matrix with a single

     matrix wich is used for the entire transformation.  It does not push or

     pop any matrices onto or off of the MODELVIEW or PROJECTION matrix

     stacks, nor does it modify the top of these stacks.  If this command is

     followed by a gSPMatrix (3P) command then the matrix supplied by

     gSPForceMatrix will be lost and will not affect the new matrix on the RSP

     (as if the gSPForceMatrix command had never been sent).





IMPORTANT NOTE

     The gSPForceMatrix command does not affect lighting.  Therefore, if you

     are using lighting and you use the gSPForceMatrix command, the lights

     will act on a rendered object according to the RSP's matrix state

     preceding the gSPForceMatrix command, but the object's position and

     orientation will be determined by the matrix sent by the gSPForceMatrix

     command.







MATRIX FORMAT

     Please see the note on Matrix Format in the gSPMatrix (3P) man page.





SEE ALSO

     gSPMatrix(3P), gSPInsertMatrix(3P)













                                                                        Page 1







