





gSPGeometryMode(3P)                                        gSPGeometryMode(3P)







NAME

     gSPSetGeometryMode, gsSPSetGeometryMode, gSPClearGeometryMode,

     gsSPClearGeometryMode - set and clear geometry pipeline modes.



C SPECIFICATION

     #include "gbi.h"



     gSPSetGeometryMode(Gfx *gdl, unsigned int mode)



     gsSPSetGeometryMode(unsigned int mode)



     gSPClearGeometryMode(Gfx *gdl, unsigned int mode)



     gsSPClearGeometryMode(unsigned int mode)





PARAMETERS

     *gdl      graphics display list pointer.



     mode      geometry pipeline modes.  Modes are bit ORed together and set

               or cleared depending on command.



               G_SHADE RSP will calculate the color at vertices of triangle.

               Do not enable this when using the primitive color to specify

               the color for a triangle.



               G_LIGHTING enable lighting calculations.



               G_SHADING_SMOOTH enable Gouraud shading.  If this is not

               enabled, the color for a triangle will be flat shaded.  The

               color of the triangle will be determined by the color of one of

               its vertices.  See gSP1Triangle(3P).  Must also set G_SHADE.



               G_ZBUFFER enable z-buffer calculations. (note you may also need

               to set other z-buffer parameters for the framebuffer)



               G_TEXTURE_GEN enable the automatic generation of the texture

               coordinates s and t.  A spherical mapping is used, based on the

               normal.



               G_TEXTURE_GEN_LINEAR enable the automatic generation of the

               texture coordinates s and t.



               G_CULL_FRONT enable culling the front-facing polygons.



               G_CULL_BACK enable culling the back-facing polygons.



               G_CULL_BOTH enable culling both the front and back-facing

               polygons.



               G_FOG enable generation of fog parameters for vertex alpha

               coordinate.







                                                                        Page 1













gSPGeometryMode(3P)                                        gSPGeometryMode(3P)







DESCRIPTION

     The gSPSetGeometryMode command is used to turn on geometry pipeline

     modes.



     gSPClearGeometryMode clears these modes.





NOTE

     There are other elements of the RSP 'rendering state' which have their

     own commands. In those cases, either the state change is more complex

     than a single bit, or there is an optimization for the RSP geometry

     engine which requires a different command.





SEE ALSO

     gSPFogPosition(3P),gDPSetPrimColor(3P),gSP1Triangle(3P)















































































                                                                        Page 2







