





gSPSetLights(3P)                                              gSPSetLights(3P)







NAME

     gSPSetLights, gsSPSetLights - load light structures into the RSP.



C SPECIFICATION

     #include "gbi.h"



     typedef struct {

       Ambient a;

       Light        l[M];

     } LightsM;



     gSPSetLightsM(Gfx *gdl, LightsM lites)



     gsSPSetLightsM(LightsM lites)





PARAMETERS

     *gdl      graphics display list pointer.



     lites     LightsM structure to load into the RSP.



     The gSPSetLightsM command loads light structures for ambient and diffuse

     lights into the light buffer. The last character in the command,

     indicated by M above, represents the number of diffuse lights in the

     scene. In the command and in the structure LightsM, M must be an actual

     integer in the range of 0 to 7. For example, with 3 diffuse lights, the

     command is gSPSetLights3 and the corresponding structure is Lights3.



     Once the lights are activated, they remain on until the next call to

     gSPSetLightsM. Whenever a new structure of lights is activated, the old

     structure of lights is overwritten.



     In the LightsM structure Ambient a is the ambient light structure, and

     Light l[M] is an array of M diffuse light structures. The LightsM

     structure can be set up by utilizing the gdSPDefLights command with the

     parameters defining the lights as inputs. The individual light structures

     combine the color of the light with the color of the material.



     Note: To change the color of some or all of the lights after the light

     has been used once or more the use of the gSPLight (3P) command is more

     efficient than the gSPSetLightsM command.  See gSPLight (3P).



SEE ALSO

     gdSPDefLights(3P) gSPLight(3P) gSPLightColor(3P)























                                                                        Page 1







