





gSPTexture(3P)                                                  gSPTexture(3P)







NAME

     gSPTexture, gsSPTexture - texture enable and coordinate scaling in RSP



C SPECIFICATION

     #include "gbi.h"



     gSPTexture(Gfx *gdl, int sc, int tc, int level, int tile, int on)



     gsSPTexture(int sc, int tc, int level, int tile, int on)





PARAMETERS

     *gdl      graphics display list pointer.



     sc, tc    texture coordinate s,t scaling parameters, 16 bits each in .16

               format.



     level     maximum number of mip-map levels - 1.



     tile      texture tile number.  Selects one of 8 texture tiles

               descriptors in the RDP.



     on        texture enable or disable.



DESCRIPTION

     This command sets the parameters in the RSP for texturing.  Resulting

     texture coordinates computed by the RSP is given by:



        out_texture_coord = scale * in_texture_coord.

9     The final output texture coordinate is a conspiracy between the sc and tc

     scale parameters, and the s,t coordinates of the model.  It is the

     application's responsibility to combine these so that the binary point in

     the final s,t values is an appropriate S10.5 format number.



     A typical example might use an sc and tc values of 0.5, then scale the

     s,t coordinates in the model up by 2.0.



     The texture tile tells the RDP which texture tile you would like to use.

     In case of mip-mapping, send the lowest number in the tile sequence that

     represent the mip-map.  In other words, the tile number of the finest

     map.  So for a sequence of tiles n, n+1, n+2 etc.  n is the finest map

     tile and the one you set in this command.  n+1, n+2 etc are the decreas-

     ing resolution tiles.  If you have detailed textures, they should be

     loaded at tile n with the finest resolution map at n+1.



     The on parameter is either G_ON or G_OFF. In the case of G_OFF, the other

     parameters are still updated, which could be a source of display list

     bugs if the state of the texture engine is assumed later.







9





                                                                        Page 1













gSPTexture(3P)                                                  gSPTexture(3P)







SEE ALSO

     gDPLoadTexture(3P) gDPSetTextureImage(3P)











































































































                                                                        Page 2







