





gtStateSetOthermode(3P)                                gtStateSetOthermode(3P)







NAME

     gtStateSetOthermode - compose an RDP 'othermode' command.



C SPECIFICATION

     #include "gt.h"



     void gtStateSetOthermode(Gfx *om, gtStateOthermode_t mode, int data)







PARAMETERS

     om        pointer to the othermode word. Usually a field from gtGlobState

               or gtState structures.



     mode      which othermode to modify. One of:



                    GT_CLEAR               clear all fields

                    GT_ALPHACOMPARE        conditional color write on

                                           alpha compare

                    GT_ZSRCSEL             choose primitive Z or pixel Z

                    GT_RENDERMODE          set the rendermode

                    GT_ALPHADITHER         select alpha dither type

                    GT_RGBDITHER           select color dither type

                    GT_COMBKEY             enable combine keying

                    GT_TEXTCONV            do texture conversion

                    GT_TEXTFILT            set texture filter

                    GT_TEXTLUT             set texture look up table

                    GT_TEXTLOD             enable texture level of detail

                    GT_TEXTDETAIL          enable texture detail

                    GT_TEXTPERSP           enable texture perspective

                    GT_CYCLETYPE           choose cycle type

                    GT_PIPELINE            set pipeline mode



               Note: some of these modes are incompatible with the turbo

               microcode features.



     data      new data to set the appropriate othermode bits. These macros

               are the same data macros defined in gbi.h.





DESCRIPTION

     This library function is used to assemble RDP 'othermode' commands for

     turbo microcode applications.



     The gspFast3D (3P) microcode presents a more user-friendly "set-and-

     clear" interface which hides the details of the RDP othermode command

     from the user.  This interface is not available with the gspTurbo3D (3P)

     microcode, so this function is necessary to construct that RDP command.















                                                                        Page 1













gtStateSetOthermode(3P)                                gtStateSetOthermode(3P)







EXAMPLE

     The render mode would normally be set with a macro from gbi.h like this:



          gDPSetRenderMode(gptr++, G_RM_OPA_SURF, G_RM_OPA_SURF2);



     To construct a similar command for the turbo object state, use:



          gtStateSetOthermode(&(state.sp.rdpOthermode),

                                 (G_RM_OPA_SURF | G_RM_OPA_SURF2));







SEE ALSO

     gspTurbo3D(3P)



















































































                                                                        Page 2







