





guLookAtHilite(3P)                                          guLookAtHilite(3P)







NAME

     guLookAtHilite, guLookAtHiliteF - computes a 'lookat' viewing matrix,

     sets up the LookAt structure with values for performing reflection

     mapping or specular hilite rendering, and computes texture offsets of two

     specular highlights (in the Hilite structure).



C SPECIFICATION

     #include "gu.h"



     void guLookAtHilite(Mtx *m, LookAt *l, Hilite *h,

               float xEye, float yEye, float zEye,

               float xAt,  float yAt,  float zAt,

               float xUp,  float yUp,  float zUp,

               float xl1,  float yl1,  float zl1,

               float xl2,  float yl2,  float zl2,

               int twidth, int theight)



     void guLookAtHiliteF(float m[4][4], LookAt *l, Hilite *h,

               float xEye, float yEye, float zEye,

               float xAt,  float yAt,  float zAt,

               float xUp,  float yUp,  float zUp,

               float xl1,  float yl1,  float zl1,

               float xl2,  float yl2,  float zl2,

               int twidth, int theight)







PARAMETERS

     m         resulting 4x4 viewing matrix.



     l         pointer to resulting LookAt structure to store colors and

               lookat directions.



     h         pointer to resulting structure to store texture offsets of two

               specular highlights.



     xEye, yEye, zEye

               eye position.



     xAt, yAt, zAt

               center of interest in the direction we are looking.



     xUp, yUp, zUp

               up direction vector.



     xl1, yl1, zl1

               direction of first specular highlight.



     xl2, yl2, zl2

               direction of second specular highlight.











                                                                        Page 1













guLookAtHilite(3P)                                          guLookAtHilite(3P)







     twidth, theight

               width and height of textures which will be used to render

               specular highlights.



DESCRIPTION

     The guLookAtHilite command returns a fixed-point 4x4 viewing matrix m. It

     sets up the LookAt structure with x and y screen space coordinate

     directions.  It sets up the Hilite structure with computed offsets into

     the texture(s) that are used to render up to two specular highlights.

     Use the gDPSetHiliteTile(3P) macro to tell the RCP how to render specular

     hilites (with the info in the Hilite struct h) and the gSPLookAt(3P)

     macro to tell the RCP how to compute texture coordinates for reflection

     mapping or specular hilite rendering (with the info in the LookAt struct

     l).



     For a detailed description of the fixed-point matrix format, see

     gSPMatrix (3P).



     The guLookAtHiliteF command returns a floating-point 4x4 viewing matrix

     m.





SEE ALSO

     gSPMatrix(3P), guLookAt(3P), guLookAtReflect(3P), gluLookAt(3G)

     gSPLookAt(3P) gDPSetHiliteTile(3P)





























































                                                                        Page 2







