





guLookAtReflect(3P)                                        guLookAtReflect(3P)







NAME

     guLookAtReflect, guLookAtReflectF - computes a 'lookat' viewing matrix

     and sets up the LookAt structures with values for performing reflection

     mapping.



C SPECIFICATION

     #include "gu.h"



     void guLookAtReflect(Mtx *m, LookAt *l,

               float xEye, float yEye, float zEye,

               float xAt,  float yAt,  float zAt,

               float xUp,  float yUp,  float zUp)



     void guLookAtReflectF(float m[4][4], LookAt *l,

               float xEye, float yEye, float zEye,

               float xAt,  float yAt,  float zAt,

               float xUp,  float yUp,  float zUp)







PARAMETERS

     m         resulting 4x4 viewing matrix.



     l         pointer to resulting LookAt structure for colors and lookat

               directions.



     xEye, yEye, zEye

               eye position.



     xAt, yAt, zAt

               center of interest in the direction we are looking.



     xUp, yUp, zUp

               up direction vector.



     The guLookAtReflect command returns a fixed-point 4x4 viewing matrix m.

     It sets up the LookAt structure with x and y screen space coordinate

     directions.  Use the gSPLookAt(3P) macro to tell the RCP how to compute

     texture coordinates for reflection mapping (with the info in the LookAt

     struct l).



     For a detailed description of the fixed-point matrix format, see

     gSPMatrix (3P).



     The guLookAtReflectF command returns a floating-point 4x4 viewing matrix

     m.





SEE ALSO

     gSPMatrix(3P), guLookAt(3P), guLookAtHilite(3P), gluLookAt(3G),

     gSPLookAt(3P)









                                                                        Page 1







