





guLookAtStereo(3P)                                          guLookAtStereo(3P)







NAME

     guLookAtStereo, guLookAtStereoF - computes a 'lookat' viewing matrix

     suitable for stereographic projections.



C SPECIFICATION

     #include "gu.h"



     void guLookAtStereo(Mtx m,

               float xEye, float yEye, float zEye,

               float xAt,  float yAt,  float zAt,

               float xUp,  float yUp,  float zUp,

               float eyedist )



     void guLookAtStereoF(float m[4][4],

               float xEye, float yEye, float zEye,

               float xAt,  float yAt,  float zAt,

               float xUp,  float yUp,  float zUp,

               float eyedist )







PARAMETERS

     m         resulting 4x4 viewing matrix.



     xEye, yEye, zEye

               eye position.



     xAt, yAt, zAt

               center of interest in the direction we are looking.



     xUp, yUp, zUp

               up direction vector.



     eyedist   the distance from the viewing axis of "this eye". If eyedist is

               positive, the resulting matrix is for the "right" eye, if

               eyedist is negative, the resulting matrix is for the "left"

               eye.



DESCRIPTION

     guLookAtStereo Returns a fixed-point 4x4 matrix m, which can be used for

     one view of a stereographic projection.  Normally this function must be

     called twice, calculating different images for the left and right eyes.

     Use a positive eyedist to calculate a matrix for rendering the right

     eye's view and the negative of that eyedist to calculate the matrix for

     the left eye's view.  Unlike the guLookAt function, the distance from the

     eye (xEye,yEye,zEye) to the At position (xAt,yAt,zAt) is important in the

     guLookAtStereo function.  The At point is where the eyes focus.





     For a detailed description of the fixed-point matrix format, see

     gSPMatrix (3P).









                                                                        Page 1













guLookAtStereo(3P)                                          guLookAtStereo(3P)







     guLookAtStereoF Returns a floating-point 4x4 matrix m.



SEE ALSO

     gSPMatrix(3P) gluLookAt(3G)







































































































                                                                        Page 2







