





guOrtho(3P)                                                        guOrtho(3P)







NAME

     guOrtho, guOrthoF - computes a orthographic projection matrix.



C SPECIFICATION

     #include "gu.h"



     void guOrtho(Mtx m, float l, float r, float b, float t,

          float n, float f, float scale)



     void guOrthoF(float m[4][4], float l, float r, float b, float t,

          float n, float f, float scale)





PARAMETERS

     m         resulting 4x4 projection matrix.



     l, r      left and right vertical clipping planes.



     b, t      bottom and top horizontal clipping planes.



     n, f      the near and far clipping planes (z-planes in world space).



     scale     scale each element of the matrix.  Can be used to improve

               precision in the RSP fixed point arithmetic.



DESCRIPTION

     This command creates a matrix for an orthographic parallel viewing

     volume. The near clipping plane is a rectangle with the lower left corner

     at (l, b, -n) and the upper right corner at (r, t, -n). The far clipping

     plane is a rectangle with corners at (l, b, -f) and (r, t, -f). Both near

     and far (n and f) can be positive or negative.  guOrtho returns a fixed

     point 4x4 matrix m. For a detailed description of the fixed-point matrix

     format, see gSPMatrix (3P).



     guOrthoF returns a floating-point 4x4 matrix m.



NOTE

     The near and far planes are specified slightly differently here than they

     are in the guPerspective(3P) command. In this command, they represent z-

     planes in world space; in guPerspective(3P) they are distances which are

     always positive.



     Larger separations between the near and far planes decrease the z

     resolution for z-buffering.





SEE ALSO

     guFrustum(3P), guPerspective(3P), guLookAt(3P), gSPMatrix(3P),

     glOrtho(3G)













                                                                        Page 1







