





guParseGbiDL(3P)                                              guParseGbiDL(3P)







NAME

     guParseGbiDL - Print a GBI display list in human readable format.



C SPECIFICATION

     #include "ultra64.h"



     void guParseGbiDL(u64 *gbi_dl, u32 nbytes, u8 flags)







PARAMETERS

     gbi_dl    pointer to Graphics Binary Interface (GBI) display list in

               DRAM.



     nbytes    number of bytes in GBI display list (0 causes entire display

               list to print.)



     flags     The following flags may be OR'd together to enable printing of

               additional information about the display list.



               GU_PARSEGBI_ROWMAJOR Print matrices in row major order.

               Otherwise printed in column major order.



               GU_PARSEGBI_NONEST Do not follow nested display lists.



               GU_PARSEGBI_FLTMTX Print matrices in floating point.



               GU_PARSEGBI_SHOWDMA Show DMA'd data.



               GU_PARSEGBI_ALLMTX Print modeling and projection matrices.



               GU_PARSEGBI_DUMPONLY Print the display list as a hexadecimal

               dump.





DESCRIPTION

     This function interprets and displays the commands and data in a GBI

     display list. For it to function you must be running the tool, dlprint on

     the Indy host.  The parameters gbi_dl and nbytes are equivelent to the

     fields data_ptr and data_size in the OSTask structure, respectively.

     Normally the nbytes (data_size) parameter is set to 0, which causes the

     entire display list to be printed.















     The GBI display list is processed by the graphics microcode running on

     the Reality Signal Processor (RSP) to produce a Reality Display Processor

     (RDP) format display list. The output of the RSP may be directed either







                                                                        Page 1













guParseGbiDL(3P)                                              guParseGbiDL(3P)







     directly to the RDP or to DRAM by using different microcode in the

     graphics task.  If the RSP's output (the RDP display list) is stored in

     DRAM, the function guParseRdpDL (3P) may be used to print it in a

     readable format (see guParseRdpDL (3P)).



SEE ALSO

     dlprint(1), guParseRdpDL(3P), alParseAbiCL(3P)

































































































                                                                        Page 2







