





guParseRdpDL(3P)                                              guParseRdpDL(3P)







NAME

     guParseRdpDL - Prints low-level display lists in human readable format.



C SPECIFICATION

     #include "gu.h"



     void guParseRdpDL(u64 *rdp_dl, u64 nbytes, u8 flags)







PARAMETERS

     rdp_dl    pointer to RDP display list in DRAM.  This is the array as

               passed in the task header. See osSpTaskLoad (3P) for further

               details.



     nbytes    number of bytes in RDP display list as returned by graphics

               task.  See osSpTaskLoad (3P) for more details.



     flags     The following flags may be OR'd together to enable printing of

               additional information about the display list.



               GU_PARSERDP_VERBOSE print extra information about display list,

               usually for debugging



               GU_PARSERDP_PRAREA print information about the area/number of

               spans of each primitive



               GU_PARSERDP_DUMPONLY print the rdp display list as a

               hexidecimal dump





DESCRIPTION

     This function dumps the Reality Display Processor (RDP) display list in

     human readable form and also checks for common errors in the display

     list. In order for this to function you must be running the tool, dlprint

     on the host Indy.



     Optionally, you can print information about the area of each primitive

     and the number of spans in a primitive. Commands are classified to be

     either primitive, attribute, sync, or load commands and a summary of the

     number of each command type is printed after the display list dump.



     The RDP display list is the output of the graphics microcode running on

     the Reality Signal Processor (RSP).  Using the proper microcode

     (microcode with a suffix of .dram), the RSP will output it's display list

     to a DRAM buffer provided by the user.  Once in DRAM, guParseRdpDL (3P)

     can be used to print the display list.  The display list in DRAM can be

     sent to the RDP using the osDpSetNextBuffer (3P) function.  This method

     is useful in isolating problems between the application, the RSP, and the

     RDP. Note that the guParseRdpDL (3P) function cannot be used with non-

     DRAM microcode (ie microcode without the .dram suffix).









                                                                        Page 1













guParseRdpDL(3P)                                              guParseRdpDL(3P)







     guParseRdpDL (3P) detects the following conditions:



         Color/Z image not in first 2 Megs

         Image pointer not in first 3 Megs

         Image pointers not properly aligned

         Missing syncs

         Illegal primitive coefficients

         Unscissored rectangles





BUGS

     There are no estimates for the number of cycle it takes to load a

     texture.  The checks for syncs are not always foolproof.  The area

     calculation for triangles sometimes reports bogus values.  Estimated

     clocks does not take into account DRAM latency, cycle type,

     Read/Modify/Write mode, etc. and so should be used only as an optimistic

     estimate of display list performance.



SEE ALSO

     dlprint(1), guParseGbiDL(3P), alParseAbiCL(3P), osSpTaskLoad(3P),

     osDpSetNextBuffer(3P),





































































                                                                        Page 2







