





guPerspective(3P)                                            guPerspective(3P)







NAME

     guPerspective, guPerspectiveF - computes a perspective projection matrix.



C SPECIFICATION

     #include "gu.h"



     void guPerspective(Mtx m, u16 *perspNorm,

               float fovy, float aspect,

               float near, float far, float scale)



     void guPerspectiveF(float m[4][4], u16 *perspNorm,

               float fovy, float aspect,

               float near, float far, float scale)







PARAMETERS

     m         resulting 4x4 projection matrix.



     perspNorm value to use with the gSPPerspNormalize command.



     fovy      field of view angle, in degrees, in the y direction.



     aspect    aspect ratio that determines the field of view in the x

               direction.  The aspect ratio is the ratio of x (width) to y

               (height) of the viewport region.



     near, far distance from the viewer to the near and far clipping plane

               (always positive).



     scale     scale each element of the matrix.  Can be used to improve

               precision in the RSP fixed-point arithmetic.



DESCRIPTION

     guPerspective returns a fixed-point 4x4 matrix m and a number to use with

     gSPPerspNormalize.



     For a detailed description of the fixed-point matrix format, see

     gSPMatrix (3P).



     guPerspectiveF returns a floating-point 4x4 matrix m.





SEE ALSO

     guFrustum(3P) guOrtho(3P) gSPMatrix(3P) gSPPerspNormalize(3P)

     gluPerspective(3G)



















                                                                        Page 1







