





osAi(3P)                                                              osAi(3P)







NAME

     osAiGetStatus, osAiGetLength, osAiSetFrequency, osAiSetNextBuffer -

     interrogate and control the audio interface (AI)



SYNOPSIS

     #include <ultra64.h>



     u32 osAiGetStatus(void);



     u32 osAiGetLength(void);



     s32 osAiSetFrequency(u32 frequency);



     s32 osAiSetNextBuffer(void *vaddr, u32 nbytes);





DESCRIPTION

     These routines provide basic control for the audio interface.



     osAiGetStatus simply returns the hardware status of the audio interface.

     In this 32-bit value, only bits AI_STATUS_FIFO_FULL and

     AI_STATUS_DMA_BUSY contain useful information. AI_STATUS_FIFO_FULL is set

     when both audio DMA registers have been programmed.  AI_STATUS_DMA_BUSY

     is set when DMA is in progress.



     Based on the input requested frequency (in Hz), osAiSetFrequency

     calculates the correct values for the internal divisors and returns the

     actual frequency generated by these divisors.  The requested frequency

     should fall between 3000 Hz and 368000 Hz on NTSC systems, or between

     3050 Hz and 376000 Hz on PAL systems.



     osAiSetNextBuffer sets up the next DMA transfer from DRAM to the audio

     interface buffer.  vaddr points to the buffer in DRAM and nbytes

     specifies the number of bytes to transfer.  Note that the buffer address

     vaddr must be 64-bit aligned and that nbytes must be a multiple of 8

     bytes.  A maximum transfer size of 262144 bytes is supported.  If the

     interface is busy (i.e. AI_STATUS_FIFO_FULL is set), osAiSetNextBuffer

     returns -1 and aborts the DMA operation.



     osAiGetLength simply returns the number of bytes remaining in the current

     DMA buffer.





KNOWN BUGS

     It is worth noting that a previous hardware bug has been fixed by a

     software patch in osAiSetNextBuffer.  This bug occurred when the address

     of the end of the buffer specified by osAiSetNextBuffer was at a specific

     value.  This value occurred when















                                                                        Page 1













osAi(3P)                                                              osAi(3P)







     (vaddr + nbytes) & 0x00003FFF == 0x00002000



     (when the end of the buffer is a number ending in a set bit followed by

     13 clear bits). In this case, the DMA transfer will not complete

     successfully.  This can cause clicks and pops in the audio output.  This

     bug no longer requires special handling by the application since it is

     patched by osAiSetNextBuffer.





NOTES

     For hardware version 1.0, the audio DMA length register is only 15-bit

     long and thus supports a maximum transfer size of 32 Kbytes. In the final

     release, this register is extended to 18 bits to support a transfer of

     256 Kbytes.



SEE ALSO

     osTvType(3P).













































































                                                                        Page 2







