





osCreateMesgQueue(3P)                                    osCreateMesgQueue(3P)







NAME

     osCreateMesgQueue, osSendMesg, osJamMesg, osRecvMesg - messaging and

     synchronization facilities



SYNOPSIS

     #include <ultra64.h>



     void osCreateMesgQueue(OSMesgQueue *mq, OSMesg *msg, s32 count);



     s32 osSendMesg(OSMesgQueue *mq, OSMesg msg, s32 flag);



     s32 osJamMesg(OSMesgQueue *mq, OSMesg msg, s32 flag);



     s32 osRecvMesg(OSMesgQueue *mq, OSMesg *msg, s32 flag);





DESCRIPTION

     Message queues provide a highly flexible communication and

     synchronization mechanism.  The facilities are useful among threads, as

     well as between threads and events (primarily interrupts).  See

     osSetEventMesg(3P) for a complete list of events.



     The osCreateMesgQueue call initializes a given OSMesgQueue structure mq

     to an empty state.  The msg argument points to a OSMesg array that is

     used for storing messages in this queue and count specifies the total

     number of messages the given queue can hold (the size of the array).



     The osSendMesg call copies the message msg to the end of the given

     message queue mq.  The flag argument specifies the blocking mode of this

     send operation.  If flag is set to OS_MESG_BLOCK, the routine blocks on a

     full message queue; that is, the invoking thread yields the CPU until

     there is an empty slot in the queue for writing.  This thread is enqueued

     onto a priority linked list associated with the message queue behind

     other threads of the same priority.  The osSendMesg call will always

     return 0 for a blocking send call.  Setting flag to OS_MESG_NO_BLOCK

     allows the osSendMesg call to return immediately with a return value of

     -1 when the message queue is full; otherwise the message is delivered and

     the call returns with a return value of 0.  Furthermore, osSendMesg call

     will resume the highest priority thread blocked in osRecvMesg waiting for

     the queue to become non empty, if indeed one is blocked.



     The osJamMesg call works like osSendMesg except that the message msg is

     copied to the front of the given message queue mq.  This call may be used

     to deliver high priority messages.



     The osRecvMesg call copies the first message in the message queue mq into

     the address specified by msg.  If a NULL msg is passed to osRecvMesg the

     message in the queue is discarded.  This is useful in cases where you

     don't care about the value of the message, only the fact that a

     synchronization event occurred.  If flag is set to OS_MESG_BLOCK, the

     routine blocks on an empty message queue; that is, the current running

     thread yields the CPU until there is a message available for reading in







                                                                        Page 1













osCreateMesgQueue(3P)                                    osCreateMesgQueue(3P)







     the queue.  This thread is enqueued onto a priority linked list

     associated with the message queue behind other threads of the same

     priority.  The osRecvMesg call will always return 0 for a blocking

     receive call.  Setting flag to OS_MESG_NOBLOCK allows the osRecvMesg call

     to return immediately with a return value of -1 when the message queue is

     empty; otherwise the message is received and the call returns with a

     return value of 0.  Finally, osRecvMesg call will resume the highest

     priority thread blocked in osSendMesg or osJamMesg waiting for a message

     queue slot to become available, if one is in fact blocked.



SEE ALSO

     osCreateThread(3P), osSetEventMesg(3P)























































































                                                                        Page 2







