





osCreateScheduler(3P)                                    osCreateScheduler(3P)







NAME

     osCreateScheduler - create a RCP task scheduler



SYNOPSIS

     #include <ultra64.h>



     void osCreateScheduler(OSSched *s, void *stack, OSPri priority, u8 mode,

                            u8 retraceCount);



PARAMETERS

     s         pointer to the scheduler structure to initialize.



     stack     pointer to the stack for the scheduler thread.



     priority  priority for the scheduler thread.



     mode      the video mode with which to initilize the Vi Manager.



     retraceCount

               the number of retraces per retrace message sent.





DESCRIPTION

     The Scheduler is a host CPU thread that is responsible for executing

     audio and graphics tasks on the RCP such that host and RCP overrun is

     minimized or eliminated.



     Each video retrace, the Scheduler reads the new tasks generated by

     scheduler client threads from the task queue and adds them to the end of

     a real-time (audio) or non-real-time (graphics) task schedule list.



     If the previous frame's graphics task has overrun, the Scheduler causes

     the task to yield. It then runs the next audio task, resuming the yielded

     task when the audio task has completely processed, and any additional

     graphics tasks that are to be run to be run in the current frame.



     When a task completes, the Scheduler sends a message to the client

     indicating that the work it requested is complete.



     In order to use the Scheduler, you must first call osCreateScheduler() to

     initialize the OSSched data structure, its message queues and the Vi

     Manager. The osCreateScheduler() function spawns a thread to schedule and

     manage task execution. One of the parameters to this call is the thread

     priority , which should be higher than that of the threads which generate

     the command lists.



SEE ALSO

     osScAddClient(3P), osScGetTaskQ(3P)















                                                                        Page 1







