





osEepromLongRead(3P)                                      osEepromLongRead(3P)







NAME

     osEepromLongRead, osEepromLongWrite - read/write multiple blocks of data

     from/to EEPROM



SYNOPSIS

     #include <ultra64.h>



     s32 osEepromLongRead(OSMesgQueue *mq, u8 address, u8 *buffer,

                          int nbytes);



     s32 osEepromLongWrite(OSMesgQueue *mq, u8 address, u8 *buffer,

                          int nbytes);





DESCRIPTION

     The osEepromLongRead call issues EEPROM read commands to obtain nbytes of

     data from the address specified by address, and the osEepromLongWrite

     call issues EEPROM write commands to write nbytes of data to the address

     specified by address. The user must supply a block of memory large enough

     for nbytes. Due to a hardware restriction, the transfer size nbytes

     should be a multiple of 8.  The message queue mq must be an initialized

     message queue associated with the OS_EVENT_SI event.  See

     osSetEventMesg(3P) for details on how to create this association. Note

     that address is the EEPROM block address and each EEPROM block contains 8

     bytes of data.



     Since the EEPROM command will take around 15 milliseconds to complete, a

     timer is set up between EEPROM commands to avoid waiting in the busy

     loop. In addition, osContInit(3P) must be called to initialize the low

     level synchronization before osEepromLongRead/osEepromLongWrite can be

     used.



SEE ALSO

     osContInit (3P), osEepromProbe (3p), osEepromRead (3p), osEepromWrite

     (3p).









































                                                                        Page 1







