





osEepromRead(3P)                                              osEepromRead(3P)







NAME

     osEepromRead, osEepromWrite - read/write data from/to EEPROM



SYNOPSIS

     #include <ultra64.h>



     s32 osEepromRead(OSMesgQueue *mq, u8 address, u8 *buffer);



     s32 osEepromWrite(OSMesgQueue *mq, u8 address, u8 *buffer);





DESCRIPTION

     The osEepromRead call issues a read EEPROM command to obtain 8 bytes of

     data from the address specified by address, and the osEepromWrite call

     issues a write EEPROM command to write 8 bytes of data to the address

     specified by address. The user must supply a block of memory large enough

     for  8 bytes.  The message queue mq must be an initialized message queue

     associated with the OS_EVENT_SI event.  See osSetEventMesg(3P) for

     details on how to create this association. Note that address is the

     EEPROM block address and each EEPROM block contains 8 bytes of data.



     The EEPROM command will take around 15 milliseconds to finish.  Thus, to

     avoid a reduction in overall system performance, a timer should be set up

     between osEepromRead/osEepromWrite commands. See osSetTimer(3p) for

     details on how to start a countdown timer.  In addition, osContInit(3P)

     must be called to initialize the low level synchronization before

     osEepromRead/osEepromWrite can be used.



SEE ALSO

     osContInit (3P), osEepromProbe (3p), osEepromLongRead (3p),

     osEepromLongWrite (3p).

















































                                                                        Page 1







