





osGetCount(3P)                                                  osGetCount(3P)







NAME

     osGetCount - get CPU Count register



SYNOPSIS

     #include <ultra64.h>



     u32 osGetCount(void);





DESCRIPTION

     The osGetCount routine returns the current value of the MIPS R4300 Count

     register, a free running counter that increments at half the CPU clock

     speed.  This counter increments at 46.875 Mhz and each counter tick

     represents approximately 21.33 nanoseconds.  When the counter reaches its

     maximum value, it will roll over to zero and continue.  Since the counter

     is 32 bits long, the counter will wrap approximately every 92 seconds.

     See OS_CYCLES_TO_NSEC(3P) for useful macros for converting to and from

     counter cycle time and nanoseconds or microseconds.



     The counter value may be used as a pseudo-random number generator or for

     short duration timing purposes.



SEE ALSO

     OS_CYCLES_TO_NSEC(3P), osTvType(3P), osGetTime(3P)































































                                                                        Page 1







