





osGetTime(3P)                                                    osGetTime(3P)







NAME

     osGetTime, osSetTime - get, set real time counter value



SYNOPSIS

     #include <ultra64.h>



     OSTime osGetTime(void);



     void osSetTime(OSTime time);





DESCRIPTION

     The osGetTime call returns the value of time since the last hard reset.

     The time is expressed in CPU Count register cycles.  For NTSC systems,

     this counter increments at 45.6375 Mhz and each counter tick represents

     approximately 21.91 nanoseconds.  For PAL systems, this counter

     increments at 46.5525 Mhz and each counter tick represents approximately

     21.48 nanoseconds.  When the counter reaches its maximum value, it will

     roll over to zero and continue.  The osSetTime call is used to set the

     real time counter value.



     See OS_CYCLES_TO_NSEC(3P) for useful macros for converting to and from

     counter cycle time and nanoseconds or microseconds.



     Note that the OSTime type is defined to be u64 and so when using

     rmonPrintf, variables of this type must be specified with %llu rather

     than %i or %u.



SEE ALSO

     osGetCount(3P), osLogEvent(3P), osSetTimer(3P), osTvType(3P)



















































                                                                        Page 1







