





osInvalDCache(3P)                                            osInvalDCache(3P)







NAME

     osInvalDCache - invalidate CPU data cache lines



SYNOPSIS

     #include <ultra64.h>



     void osInvalDCache(void *vaddr, s32 nbytes);





DESCRIPTION

     The MIPS R4300 CPU implements a 8 kilobyte direct mapped data cache with

     a line size of 16 bytes.  The cache is not coherent with respect to

     physical memory and thus cache lines must be explicitly invalidated when

     it is desired that stale data not be used when more recent data exists in

     physical memory.  The osInvalDCache call invalidates all data cache lines

     that contain the region [vaddr, vaddr + nbytes).  The given address vaddr

     must be a CPU virtual address, either direct mapped or mapped via the CPU

     TLB.  If vaddr is not aligned to the a cache line boundary, and nbytes is

     not a multiple of the cache line size, a slightly larger region may be

     invalidated.



     This routine is most commonly used in the situation where newer program

     data is to be copied to physical memory from a direct memory access

     device (DMA) at address locations that have been previously been read or

     written by the CPU.  In this case, the cached data is out of data with

     respect to physical memory, and thus cache lines associated with these

     addresses must be invalidated prior to accessing these data locations.



SEE ALSO

     osMapTLB(3P), osInvalICache(3P), osWritebackDCache(3P)



















































                                                                        Page 1







