





osPfsChecker(3P)                                              osPfsChecker(3P)







NAME

     osPfsChecker  - Check and repair filesystems for CONTROLLER PAK



SYNOPSIS

     #include <ultra64.h>



     s32 osPfsChecker(OSPfs *pfs);





DESCRIPTION

     The osPfsChecker function audits and repairs inconsistent conditions for

     the filesystem given by pfs. If the filesystem is inconsistent, the

     PFS_CORRUPTED bit in status of pfs is set and osPfsChecker attempts to

     make correction. Most corrective actions result in some loss of data.

     The OSPfs handle must be the handle returned from osPfsInit. See

     osPfsInit(3P) for details on how to create this handle. Application

     should always call osPfsChecker when  the error code PFS_ERR_INCONSISTENT

     is returned from any function.



     A value of 0 is returned if the calls succeed, otherwise one of the

     following error code is returned.



          PFS_ERR_NOPACK       No CONTROLLER PAK is plugged in the

                               specified controller.



          PFS_ERR_CONTRFAIL    The controller sends data at higher data

                               transfer rate than the hardware handling

                               capability or the hardware CRC error

                               occurs.



          PFS_ERR_INCONSISTENT File system inode reading failed.



SEE ALSO

     osContInit (3P), osPfsAllocateFile (3P), osPfsFileState (3P),

     osPfsFreeBlocks (3P), osPfsInit (3P), osPfsIsPlug (3P), osPfsReSizeFile

     (3P), osPfsReadWriteFile (3P), osPfsSetLabel (3P)







































                                                                        Page 1







