





osPfsFileState(3P)                                          osPfsFileState(3P)







NAME

     osPfsFileState - Get file status



SYNOPSIS

     #include <ultra64.h>



     s32 osPfsFileState(OSPfs *pfs, s32 file_no, OSPfsState *state);





DESCRIPTION

     The osPfsFileState function obtains information about a file known by the

     file descriptor file_no, obtained from a successful osPfsAllocateFile

     (3P) or osPfsFindFile (3P) function call. state is a pointer to a

     OSPfsState structure into which information is placed concerning the

     file.  The OSPfs handle must be the handle returned from osPfsInit. See

     osPfsInit (3P) for details on how to create this handle.



     The contents of the structure pointed to by state include the following

     members:



          typedef struct {

                    u32     file_size;      /* file size in bytes */

                    u32     game_code;

                    u16     company_code;

                    char    ext_name[4];

                    char    game_name[16];

          }





     A value of 0 is returned if the calls succeed, otherwise one of the

     following error code is returned.



          PFS_ERR_CONTRFAIL    The controller sends data at higher data

                               transfer rate than the hardware handling

                               capability or the hardware CRC error

                               occurs.



          PFS_ERR_INVALID      Invalid parameter or the specified file

                               does not exist. Application should change

                               parameter and then retry.



          PFS_ERR_NEW_PACK     CONTROLLER PAK has been changed to a

                               different one. Application needs to call

                               osPfsInit(3p) to initialize the new

                               CONTROLLER PAK.



          PFS_ERR_INCONSISTENT File system is corrupted. Application needs

                               to call osPfsChecker(3P) to repair the file

                               system.













                                                                        Page 1













osPfsFileState(3P)                                          osPfsFileState(3P)







SEE ALSO

     osContInit (3P), osPfsAllocateFile (3P), osPfsChecker (3P),

     osPfsFreeBlocks (3P), osPfsInit (3P), osPfsIsPlug (3P), osPfsReSizeFile

     (3P), osPfsReadWriteFile (3P), osPfsSetLabel (3P)







































































































                                                                        Page 2







