





osPfsFreeBlocks(3P)                                        osPfsFreeBlocks(3P)







NAME

     osPfsFreeBlocks, osPfsNumFiles - Summarize CONTROLLER PAK usage



SYNOPSIS

     #include <ultra64.h>



     s32 osPfsFreeBlocks(OSPfs *pfs, s32 *bytes_not_used);



     s32 osPfsNumFiles(OSPfs *pfs, s32 *max_files, s32 *files_used);





DESCRIPTION

     The osPfsFreeBlocks function returns the size of free space contained in

     the given CONTROLLER PAK back to bytes_not_used.



     The osPfsNumFiles function returns the maximum file number limit of the

     given pfs back to max_files. It also returns the number of existing files

     back to files_used.



     A value of 0 is returned if the calls succeed, otherwise one of the

     following error code is returned.



          PFS_ERR_CONTRFAIL    The controller sends data at higher data

                               transfer rate than the hardware handling

                               capability or the hardware CRC error

                               occurs.



          PFS_ERR_INVALID      Invalid parameter or the specified file

                               does not exist.  Application should change

                               parameter and then retry.



          PFS_ERR_NEW_PACK     CONTROLLER PAK has been changed to a

                               different one. Application needs to call

                               osPfsInit(3p) to initialize the new

                               CONTROLLER PAK.



          PFS_ERR_INCONSISTENT File system is corrupted. Application needs

                               to call osPfsChecker(3P) to repair the file

                               system.





SEE ALSO

     osContInit (3P), osPfsAllocateFile (3P), osPfsChecker (3P),

     osPfsFileState (3P), osPfsInit (3P), osPfsIsPlug (3P), osPfsReSizeFile

     (3P), osPfsReadWriteFile (3P), osPfsSetLabel (3P)





















                                                                        Page 1







