





osPfsIsPlug(3P)                                                osPfsIsPlug(3P)







NAME

     osPfsIsPlug - poll for CONTROLLER PAK



SYNOPSIS

     #include <ultra64.h>



     s32 osPfsIsPlug(OSMesgQueue *mq, u8 *bitpattern);





DESCRIPTION

     The osPfsIsPlug call returns a bit pattern to indicate which game

     controllers with CONTROLLER PAKs.  The message queue mq must be an

     initialized message queue associated with the OS_EVENT_SI event.  See

     osSetEventMesg(3P) for details on how to create this association.  Since

     the osPfsIsPlug routine will wait on the message queue mq, this queue

     must not be shared.  In addition, it is required that osContInit(3P) must

     be called to initialize the low level synchronization before osPfsIsPlug

     can be called.



     A value of 0 is returned if the calls succeed, otherwise -1 is returned.



EXAMPLE

     main()

     {

          OSMesgQueue  intMesgQueue;

          OSMesg       intMesgBuf[1];

          OSContStatus sdata[MAXCONTROLLERS];

          u8           cont_pattern, pak_pattern;



          osCreateMesgQueue(&intMesgQueue, intMesgBuf, 1);

          osSetEventMesg(OS_EVENT_SI, &intMesgQueue, dummyMessage);

          osContInit(&intMesgQueue, &cont_pattern, &sdata[0]);

          osPfsIsPlug(&intMesgQueue, &pak_pattern);

     }



SEE ALSO

     osContInit (3P), osPfsAllocateFile (3P), osPfsChecker (3P),

     osPfsFileState (3P), osPfsFreeBlocks (3P), osPfsInit (3P),

     osPfsReSizeFile (3P), osPfsReadWriteFile (3P), osPfsSetLabel (3P)

































                                                                        Page 1







