





osPfsReadWriteFile(3P)                                  osPfsReadWriteFile(3P)







NAME

     osPfsReadWriteFile - Read/Write a file



SYNOPSIS

     #include <ultra64.h>



     s32 osPfsReadWriteFile(OSPfs *pfs, s32 file_no, u8 flag, int offset,

                            int nbytes, u8 * data_buffer);





DESCRIPTION

     Base on the input flag (PFS_READ or PFS_WRITE), the osPfsReadWriteFile

     function attempts to read or write nbytes bytes from/to the file

     associated with file_no into the buffer pointed to by data_buffer.

     file_no is a file descriptor obtained from a successful osPfsAllocateFile

     (3P) or osPfsFindFile (3P) function call.  The transaction of data

     proceeds from the position in the file indicated by offset, as measured

     in bytes from the beginning of the file. Both offset and nbytes must be

     multiple of BLOCKSIZE bytes and must be less than file size.  The Pfs

     handle must be the handle returned from osPfsInit. See osPfsInit (3P) for

     details on how to create this handle.



     Note that the file is not allowed to grow on the write. The application

     should declare the size needed on allocation time or use osPfsReSizeFile

     (3P) to grow/truncate the file.



     A value of 0 is returned if the calls succeed, otherwise one of the

     following error code is returned.



          PFS_ERR_CONTRFAIL    The controller sends data at higher data

                               transfer rate than the hardware handling

                               capability or the hardware CRC error

                               occurs.



          PFS_ERR_INVALID      Invalid parameter or the specified file

                               does not exist. Application should change

                               parameter and then retry.



          PFS_ERR_NEW_PACK     CONTROLLER PAK has been changed to a

                               different one. Application needs to call

                               osPfsInit(3p) to initialize the new

                               CONTROLLER PAK.



          PFS_ERR_INCONSISTENT File system is corrupted. Application needs

                               to call osPfsChecker(3P) to repair the file

                               system.



          PFS_ERR_BAD_DATA     The data read from CONTROLLER PAK are bad.

                               Application should just ignore the data.













                                                                        Page 1













osPfsReadWriteFile(3P)                                  osPfsReadWriteFile(3P)







SEE ALSO

     osContInit (3P), osPfsAllocateFile (3P), osPfsChecker (3P),

     osPfsFileState (3P), osPfsFreeBlocks (3P), osPfsInit (3P), osPfsIsPlug

     (3P), osPfsReSizeFile (3P), osPfsSetLabel (3P)







































































































                                                                        Page 2







