





osPiRawStartDma(3P)                                        osPiRawStartDma(3P)







NAME

     osPiRawStartDma, osPiRawWriteIo, osPiRawReadIo, osPiGetStatus - unmanaged

     access to the parallel interface (PI)



SYNOPSIS

     #include <ultra64.h>



     s32 osPiRawStartDma(s32 direction, u32 devAddr, void *vAddr,

               u32 nbytes);



     s32 osPiRawWriteIo(u32 devAddr, u32 data);



     s32 osPiRawReadIo(u32 devAddr, u32 *data);



     u32 osPiGetStatus(void);





DESCRIPTION

     The parallel interface (PI) is responsible for the transport of data

     between RDRAM and bulk-storage devices (BSD) which could be ROM, RAM,

     CDROM, and other technologies.  These functions listed above provide low

     level access to the PI.  These functions should only be used when it is

     ensured that there is no other services accessing the PI. For this

     reason, it is recommended that "cooked" or managed PI access routines be

     used for most purposes; see osPiStartDma(3P) for details on this

     functionality.  The raw routines may be useful, however, immediately

     after the application boot procedure is entered and before the operating

     system is initialized.  Based on the input direction (OS_READ or

     OS_WRITE), osPiRawStartDma sets up a DMA transfer between RDRAM virtual

     address vAddr and PI device address devAddr. The length count nbytes

     contains the number of bytes to transfer (up to 16 Mbytes) and must be a

     multiple of 2 bytes.  The PI device address devAddr must be 2-byte

     aligned.  The RDRAM virtual address vAddr must be at least  8-byte

     aligned, but for OS_READ DMA operations, a stricter alignment is

     recommended.  See OS_DCACHE_ROUNDUP_ADDR(3P) for a description of the

     problems that may result when transfers are not an integral number of

     cache lines.  The osPiRawStartDma routine also polls the interface for

     idleness before programming the DMA registers.



     The osPiRawWriteIo routine performs a 32-bit programmed IO write to the

     PI device address devAddr. It polls the interface for idleness before

     performs the operation.  Similarly, osPiRawReadIo performs a 32-bit

     programmed IO read from the PI device address devAddr and returns the

     value in data. It also polls the interface for idleness before performs

     the operation.  Note that the device address devAddr must be 2-byte

     aligned.



     osPiGetStatus simply returns the hardware status of PI.  The 32-bit

     returned value contains the following bit patterns:













                                                                        Page 1













osPiRawStartDma(3P)                                        osPiRawStartDma(3P)







     PI_STATUS_IO_BUSY

               A previously issued programmed IO request has not yet

               completed.



     PI_STATUS_DMA_BUSY

               A previously issued DMA request has not yet completed.



     PI_STATUS_ERROR

               An IO request was issued while DMA was busy.



     The osPiGetStatus routine will most likely be used to ensure that the

     last of a string of raw IO requests has completed.



SEE ALSO

     osPiStartDma(3P)

















































































                                                                        Page 2







