





osReadHost(3P)                                                  osReadHost(3P)







NAME

     osReadHost, osWriteHost, osTestHost, osAckRamromRead, osAckRamromWrite -

     transfer data from/to host and DRAM



SYNOPSIS

     #include <ultra64.h>



     void osReadHost(void *vAddr, s32 nbytes);



     void osWriteHost(void *vAddr, s32 nbytes);



     void osAckRamromRead(void);



     void osAckRamromWrite(void);



NO LONGER SUPPORTED

     s32 osTestHost(void);







DESCRIPTION

     These routines allow the game to transfer data back and forth from a host

     application. They work with the routines described in uhOpenGame(3P) on

     the host side.



     The osReadGame routine will set up the game side connection to accept

     nbytes of data from the host and copy it to DRAM beginning at the address

     vAddr.  For correct synchronization, it should be paired from the game

     side with a uhWriteGame with exactly the same number of bytes.  If the

     read is attempted from the game side before the host has executed the

     write, the game thread will block.  Conversely, if the write is attempted

     from the host side before the game has executed a read, the host process

     will block.  When both sides have correctly made the corresponding

     procedure call, the transfer will take place and the blocking side will

     proceed.



     The osWriteHost routine will attempt to copy nbytes of data from the game

     beginning at vAddr to the host.  In this case, the operation should be

     paired on the host side with a uhReadGame procedure with the same byte

     count.  As above, either the host or game will block until the rendezvous

     is complete.



     The DRAM virtual address vAddr should be 8 byte (64 bit) aligned.  Due to

     a host restriction, the transfer size nbytes should be a multiple of 4.

     In addition, it is required that rmon be running to manage the low level

     synchronization.



     The osTestHost is no longer supported.



     The osAckRamromRead and osAckRamromWrite routines are used in conjunction

     with uhReadRamrom and uhWriteRamrom Under the current release, they are

     not needed, however dummy stubs remain in the library for backwards







                                                                        Page 1













osReadHost(3P)                                                  osReadHost(3P)







     compatibility.



     See uhOpenGame(3P) for an example on how to correctly initiate and use a

     connection from the host.







































































































                                                                        Page 2







