





osSetEventMesg(3P)                                          osSetEventMesg(3P)







NAME

     osSetEventMesg - associate a message queue and message with an event



SYNOPSIS

     #include <ultra64.h>



     void osSetEventMesg(OSEvent e, OSMesgQueue *mq, OSMesg m);





DESCRIPTION

     The osSetEventMesg associates a message queue and a message with an

     event, which usually corresponds to an interrupt or an exception of some

     kind.  When an event occurs, the message registered with osSetEventMesg

     is sent to the associated message queue.  The message sending is of the

     non-blocking form; if the message queue is full the message will be

     dropped.



     The following events are supported:



     OS_EVENT_SW1

               CPU software interrupt 1; although supported by the CPU, this

               is not expected to be widely used.



     OS_EVENT_SW2

               CPU software interrupt 2; not expected to be widely used.



     OS_EVENT_CART

               Indy has written to GIO bus register; intended for use by rmon.



     OS_EVENT_COUNTER

               CPU COUNT register has reached COMPARE value; intended for use

               by the VI/Timer manager.



     OS_EVENT_SP

               Signal Processor (SP) interrupt; intended for application use

               to indicate SP task completion.



     OS_EVENT_SI

               Serial Interface (SI) interrupt; intended for application use

               to indicate controller input is available.



     OS_EVENT_AI

               Audio Interface (AI) interrupt; intended for application use to

               indicate audio buffer has been consumed.



     OS_EVENT_VI

               Video Interface (VI) interrupt; intended for application use to

               indicate vertical retrace.



     OS_EVENT_PI

               Parallel Interface (PI) interrupt to indicate DMA done;

               intended for use by the PI manager.







                                                                        Page 1













osSetEventMesg(3P)                                          osSetEventMesg(3P)







     OS_EVENT_DP

               Display Processor (DP) interrupt triggered by DP FullSync

               command; intended for application use to indicate end of

               display processing.



     OS_EVENT_PRENMI

               An NMI has been requested and will occur in 0.5 seconds;

               intended for application use to begin graceful shutdown.



     OS_EVENT_CPU_BREAK

               The CPU has hit a breakpoint; intended for use by rmon.



     OS_EVENT_SP_BREAK

               The SP has hit a breakpoint; intended for use by rmon.



     OS_EVENT_FAULT

               The CPU has encountered an unrecoverable exception; intended

               for use by rmon.



     OS_EVENT_THREADSTATUS

               A thread has been created or destroyed; intended for use by

               rmon.



SEE ALSO

     osCreateMesgQueue(3P), osSendMesg(3P), osSpTaskLoad(3P), osContInit(3P),

     osAiSetNextBuffer(3P), osViSetEvent(3P), osPiStartDma(3P),

     osDpSetNextBuffer(3P)

























































                                                                        Page 2







