





osSetTimer(3P)                                                  osSetTimer(3P)







NAME

     osSetTimer, osStopTimer - start, stop an interval/countdown timer



SYNOPSIS

     #include <ultra64.h>



     int osSetTimer(OSTimer *timer, OSTime countdown, OSTime interval,

                 OSMesgQueue *mq, OSMesg msg);



     void osStopTimer(OSTimer *timer);





DESCRIPTION

     The osSetTimer call sets the value for the  timer specified by timer.

     This call supports both countdown timers and interval timers.  If

     countdown is non-zero, it indicates the time to the next timer

     expiration.  If interval is non-zero, it specifies a value to be used in

     reloading the timer when the timer expires.  The message msg is copied to

     the end of the given message queue mq when the timer expires. osSetTimer

     always returns 0.



     The osStopTimer call stops the specified interval timer.  There is not

     need to call osStopTimer if only the countdown timer is enabled in the

     osSetTimer call.



     Both countdown and interval are expressed in CPU Count register cycles.

     This counter increments at 46.875 Mhz and each counter tick represents

     approximately 21.33 nanoseconds.  See OS_CYCLES_TO_NSEC(3P) for useful

     macros for converting to and from counter cycle time and nanoseconds or

     microseconds.



     Note, to avoid a reduction in overall system performance, time values

     should not be set to less than 50 micro seconds.



SEE ALSO

     osGetTime(3P)







































                                                                        Page 1







