





osStartThread(3P)                                            osStartThread(3P)







NAME

     osStopThread - suspend a thread



SYNOPSIS

     #include <ultra64.h>



     void osStopThread(OSThread *t);





DESCRIPTION

     The osStopThread call will suspend the given thread t, preventing it from

     becoming runnable until a subsequence call to osStartThread on the same

     thread.  If t is NULL, the running thread is stopped and the dispatcher

     is invoked to run the new highest priority runnable thread.  If t is not

     the invoking thread, it should either be on the run queue or on a queue

     of threads blocked to send or receive a mesage.  In these cases,

     osStopThread simply removes the thread from the queue it is on.  The

     osStartThread call will restore the thread to that queue.



     This method of implementation, though efficient, has some side effects.

     Intuitively, one would expect the following sequence to have no effect:



        osStopThread(t);

        osStartThread(t);

9     Due to the fact that the thread t is removed and then reinserted into the

     queue, it will be moved after all of the other threads of the same prior-

     ity, and cause a change in behavior.



SEE ALSO

     osCreateThread(3P), osGetThreadId(3P), osGetThreadPri(3P),

     osStartThread(3P), osYieldThread(3P)









































9





                                                                        Page 1







