





osVirtualToPhysical(3P)                                osVirtualToPhysical(3P)







NAME

     osVirtualToPhysical, osPhysicalToVirtual - translate to, from a CPU

     virtual address to a physical memory address



SYNOPSIS

     #include <ultra64.h>



     u32 osVirtualToPhysical(void *vaddr)



     void *osPhysicalToVirtual(void *paddr)





DESCRIPTION

     The osVirtualToPhysical routine will translate an arbitrary CPU virtual

     address to its physical address, if such a translation exists.  If the

     address is KSEG0 or KSEG1 address, the returned result is equivalent to

     that of OS_K0_TO_PHYSICAL or OS_K1_TO_PHYSICAL, respectively.  Otherwise

     the address is part of a TLB mapped address space (KUSEG, KSSEG, or

     KSEG3) and the TLB is probed to determine if a mapping exists for the

     given address.  If so, the corresponding physical address is returned;

     otherwise, -1 is returned.



     The osPhysicalToVirtual routine is simply a function version of

     OS_PHYSICAL_TO_K0(3P), and thus returns the direct mapped, cached (KSEG0)

     address corresponding to paddr.



SEE ALSO

     osTLBMap(3P), OS_K0_TO_PHYSICAL(3P), OS_K1_TO_PHYSICAL(3P),

     OS_PHYSICAL_TO_K0(3P), OS_PHYSICAL_TO_K1(3P)





















































                                                                        Page 1







