





spIntro(3P)                                                        spIntro(3P)







NAME

     sp, spIntro - Introduction to Sprite Manipulation Functions



SYNOPSIS

     #include <sp.h>



     void spInit( Gfx *glistp );

     void spFinish( Gfx *glistp );

     void spMove( Sprite *sp, s32 xpos, s32 ypos );

     void spScale( Sprite *sp, f32 xscale, f32 yscale );

     void spFlip( Sprite *sp, u32 fliph, u32 flipv );

     void spSetZ( Sprite *sp, s32 z );

     void spColor( Sprite *sp, u8 red, u8 green, u8 blue, u8 alpha );

     void spSetAttribute( Sprite *sp, u32 attributes );

     void spClearAttribute( Sprite *sp, u32 attributes );

     void spScissor( u32 xmin, u32 xmax, u32 ymin, u32 ymax );

     Gfx *spDraw( Sprite *sp );







DESCRIPTION

     sp.h contains data structure type definitions, symbolic attribute names,

     and function prototypes.  The data structures used by the sprite library

     are described in detail in the Sprites chapter of the Developers Guide.

     Attributes are listed and described in the spSetAttribute and

     spClearAttribute man pages and where appropriate in other pages.



     spInit is called at the beginning of sprite drawing. Some GBI display

     list commands are added to the specified glistp to get the RCP into the

     correct mode for sprite rendering.  This sets default texturing modes.



     spFinish is called at the end of sprite drawing. Some GBI display list

     commands are added to the specified glistp to get the RCP to complete all

     pending drawing operations and reset the RCP to its regular state.  It

     also tacks on a gEndDisplayList().



     spMove sets the screen position of the upper left-hand corner of the

     sprite.



     spScale sets the resizing amount for this sprite. Scales may be less than

     1.0 to produce a smaller image, or greater than one to create an expanded

     image.



     spFlip controls the orientation of the sprite. Details to be worked out.

     (NOT CURRENTLY USED!!!)



     spSetZ sets the zbuffer depth of the sprite.  This may cause the sprite

     to be obscured by previously drawn sprites that were drawn with a smaller

     value of Z.  (NOT CURRENTLY USED!!!)













                                                                        Page 1













spIntro(3P)                                                        spIntro(3P)







     spColor sets the color of the sprite.  Based on how the sprite is to be

     drawn, this could be either the PRIMITIVE_COLOR or the FILL_COLOR.



     spSetAttribute sets the indicated attributes.  attributes can be the

     bit-wise OR of many attributes.



     spClearAttribute clears the indicated attributes.  attributes can be the

     bit-wise OR of many attributes.



     spScissor bounds the region in which sprites will be drawn.  Tiles of

     sprites which lie entirely outside this region are not added to the

     output display list.  Tiles which cross the boundry are appropriately

     clipped.



     spDraw constructs a display list starting at sp->next_dl that will draw

     the sprite into the frame buffer in the indicated way.  This display list

     is terminated with an gEndDispalyList() entry and the sp->next_dl entry

     is updated to point to one entry past this.  The pointer to the start of

     this display list is returned.



SEE ALSO

     mksprite(1P)



































































                                                                        Page 2







