





spSetAttribute(3P)                                          spSetAttribute(3P)







NAME

     spSetAttribute, spClearAttribute - Set or Clear the indicated attributes



C SPECIFICATION

     #include <sp.h>



     void spSetAttribute(Sprite *sp, u32 attributes)



     void spClearAttribute(Sprite *sp, u32 attributes)





PARAMETERS

     *sp       pointer to the sprite.



     attributes

               Bit-wise OR of attributes to be changed



DESCRIPTION

     These functions modify the sprite's current attributes.  Attributes

     control how the sprite is to be drawn



           SP_TRANSPARENTUse Alpha to blend sprite with frame-buffer.

           SP_CUTOUT     Use AlphaCompare to not draw pixels with

                         an alpha < blendcolor.alpha (automatically set to 1).

                         This can also be used in COPYMODE to disable writing

                         16-bit RGBA texels with the alpha bit off.

           SP_HIDDEN     Don't draw this sprite.

           SP_Z          Use zbuffering to determine sprite visibility.

           SP_SCALE      Use sprite scaling factors.

           SP_FASTCOPY   Use COPY mode to draw sprite into frame-buffer

                         This runs the fastest, but doesn't allow resizing or

                         high quality transparency.

           SP_TEXSHIFT   Shifts texture exactly 1/2 texel in both s and t

                         before drawing it.  This creates a better anti-aliased

                         edge along transparent texture boundaries when in

                         CUTOUT mode.

           SP_FRACPOS    Uses frac_s and frac_t fields of sprite structure

                         to fine-position the texture into the the drawn pixels.

                         This allows the texture to be moved as little as 1/32 of

                         a texel.

           SP_TEXSHUF    Indicates the Tile textures have their odd lines

                         pre-shuffled to work around a LoadTextureBlock problem.

                         See Texture document for a descrpition of this problem.

           SP_EXTERN     Force sprite drawing to use existing drawing modes

                         instead of explicitly setting them.  The application must be

                         sure to get all of the details exactly correct.  The next drawn

                         sprite will assume nothing about the current drawing modes.



SEE ALSO

     spDraw(3P)











                                                                        Page 1







