





DIS(1)                                                                  DIS(1)







NAME

     gdis - disassemble an object file



SYNOPSIS

     gdis [ options ] file



DESCRIPTION

     gdis disassembles object files into machine instructions. The options are

     as follows:



     -b  beginaddress

              disassemble starting at the given address.  The address can be

              in decimal, octal (with a leading 0), or hexadecimal (with a

              leading 0x).



     -d   section

              disassemble the named section as data, printing the offset from

              the beginning of the section.



     -C       demangle C++ names.



     -D  section

              disassemble the named section as data, printing the actual

              address of the data.



     -e  endaddress

              disassembly stops at the given address.  The address can be in

              decimal, octal (with a leading 0), or hexadecimal (with a

              leading 0x).



     -F  function

              disassemble the named function only in each object file

              specified on the command line.  This option may be specified

              multiple times on the command line.



     -h       substitute the general register names for the software register

              names in the output.



     -H       remove the leading source line, leaving hex value and the

              instructions.



     -i       remove the leading source line and hexadecimal value of

              disassembly, leaving only the instructions.



     -I  directory

              use the directory to help find the source code.



     -l  string

              disassemble the archive file specified by string.  For example,

              gdis -l x would add usr/lib/libx.a to the files to be

              disassembled.









                                                                        Page 1













DIS(1)                                                                  DIS(1)







     -L       look up source labels for subsequent printing.  This option

              works only if the file was compiled with debugging information.



     -o       print addresses and contents in octal.  The default is

              hexadecimal.



     -p   function

              Exactly the same meaning as -F function



     -s       perform symbolic disassembly where possible.  Symbolic

              disassembly output will appear on the line following the

              instruction.  Symbol names will be printed in C syntax.  This is

              the default unless the -svr4 option is given.



     -svr4    Print using svr4 output format.  This means (if no other options

              given) no externals are named (when loading data off of the $gp

              register).



     -S       display source code intermixed with the assembly code.  There is

              no guarantee that the source code displayed is the source code

              used to compile the function, since gdis simply looks for a

              source file starting with name/path given in the object and

              continuing by looking in directories specified with -I (if any)

              and accepts the first appropriately-named file it finds as the

              source file.



     -T       trace flag is for debugging of the disassembler itself.



     -t  section

              disassemble the named section as a text section.



     -V       print the version of gdis being executed.



     -w       attempts to print source information (names of user variables

              involved) after (to the right of) assembly codes.  This option

              comes into effect only if -s is also specified, but does not

              imply -s.  (But recall from above that -s is on by default

              unless -svr4 is specified, so -w is effective by itself unless

              -svr4 was specified.)



     -x       prints offsets as hex numbers. This is the default.



     If the -d, -D or -t options are specified, only those named sections from

     each user-supplied filename will be disassembled.  Otherwise, all

     sections containing text will be disassembled.





















                                                                        Page 2







