





buildtask(1P)                                                    buildtask(1P)







NAME

     buildtask - simple "linker" for Ultra64 RSP programs.





SYNOPSIS

     buildtask [-d off] [-f file] [-o file]   [-s cnt] [-l len] [-p file] obj

     ...



DESCRIPTION

     This program is a crude "linker" that concatenates RSP objects, both text

     sections and data sections, resulting in a new RSP object.



     For each object, it enforces 64-bit alignment, computes lengths and

     offsets, and updates the data section with this information.



     The result is a single RSP object with all the information necessary to

     perform code overlays at run time.



   Command Line Options:

          -s <cnt>    skip a number of words at the beginning of the text

                      section of an object, before concatenation.



          -l <len>    force object length.



          -p <file>   append a "pre-file" for this object, before

                      concatenation. The contents of <file> will be

                      concatenated to the output text section before

                      processing the next object.



          -d <off>    DMEM offset for overlay table. The default is 0x0 (top

                      of DMEM).



          -o <file>   output filename.



          -f <count>  number of DMEM files to use. Any DMEM files encountered

                      after <count> objects have been processed will be

                      ignored. This is useful for overlays which share the

                      same DMEM image.





     The -s, -l, and -p flags affect the next object. They may appear multiple

     times, affecting different objects.



     obj is an RSP object files to be concatenated. Multiple objects can be

     specified, they are concatenated in the order given on the command line.



   Overlay Table:

     During processing, the lengths and offsets are computed for each overlay.

     This information is stored in DMEM at the offset supplied by the -d flag

     (default is 0x0).











                                                                        Page 1













buildtask(1P)                                                    buildtask(1P)







     The format of this overlay table is:



          offset      32 bits, the offset of this object from the beginning of

                      the text section.



          size        16 bits, the size of this object.



          destination 16 bits, the destination of this overlay (in IMEM). This

                      field is not generated by buildtask, it is usually

                      generated by the assembler (or hard-coded).





NOTE

     This program depends on the usage of the OSTask structure, and works in

     conjunction with the boot microcode and the microcode that actually

     performs the overlay.





SEE ALSO

     rspasm(1P), osSpTaskStart(3P)







































































                                                                        Page 2







