





gload(1P)                                                            gload(1P)







NAME

     gload - game loader for Ultra 64 development system



SYNOPSIS

     gload [-a "appstring"] [-f log format file]

     [-o rom offset] [-n] [-V] [-v] [-s] [romImage filename]



DESCRIPTION

     gload is a utility which downloads a prepared rom image into the

     "cartridge memory" on the Ultra 64 development board.  We refer to this

     as "ramrom" memory, because it is ram memory which occupies 16MB of space

     where a rom cartridge would ordinarily reside on the real game hardware.



     Command line options are:



          -a <"application-argument-string">

                      The ascii contents of the quoted text string following

                      the -a argument are loaded into ramrom memory at the

                      standard offset location RAMROM_APP_WRITE_ADDR, which is

                      defined when <ultra64.h> is included.



          -f <log format file>

                      An alternate file for specifying the format of strings

                      corresponding to logging events (see below).  If not

                      specified, gload looks for the log.fmt file in the

                      current directory.



          -o <rom offset>

                      Overrides the default rom load location of zero (this is

                      intended for SGI internal debugging, not for the general

                      user).



          -s          Exit immediately after loading and starting the game.



          -n          Do not load or use a rom image. This will start the

                      print server.



          -V          Verify mode; all downloaded ramrom memories are readback

                      and verified.



          -v          Sets a verbose flag, which will print out any errors

                      detected when the ramrom memory is read back and

                      verified.



          By default, gload does not exit after loading the game image but

          acts as a server for error, print, and logging requests by the

          application.  The gload program reads the log format file, by

          default log.fmt, to determine how to expand event log codes and

          their arguments into formatted strings.  The log format file

          consists of a number of lines of the form:











                                                                        Page 1













gload(1P)                                                            gload(1P)







              <code>     <printf-like format string>



          The format string is "printf-like" because it does not support 64

          bit formats such as "%ll" and interprets the floating point formats

          as single precision, not double precision.  See osLogEvent(3P) for

          more details.



          The default error handler for the debug version of the library also

          uses this mechanism for formatting of error strings; it uses the

          global format file /usr/lib/PR/error.fmt for this purpose.



NOTE

     After each memory image is loaded (rom and application arguments), gload

     reads back the memory and verifies the contents.  Once both memory images

     have been individually loaded, gload goes back and verifies the integrity

     of each section one more time to make sure that none of the memory images

     overlapped each another.



     All writes and reads to and from ramrom memory are made via the ultra64

     device driver, which must be installed and configured into your kernel;

     also, the /dev/u64 and/dev/u64_print special device files must exist with

     proper read/write permissions).



SEE ALSO

     makerom(1P), osExit(3P), osLogEvent(3P), osSyncPrintf(3P),



FILES

     /dev/u64, /dev/u64_print, /dev/u64_logging, /dev/u64_fault,

     /usr/lib/PR/error.fmt





















































                                                                        Page 2







