





osSyncPrintf(3P)                                              osSyncPrintf(3P)







NAME

     osSyncPrintf - do formatted printing through debug port



SYNOPSIS

     #include <os.h>



     void osSyncPrintf(const char *format, .../* args */);





DESCRIPTION

     The osSyncPrintf call performs text formatting similar to the libc

     function printf. The text output is transmitted from the target system

     via the debug port to the gload process running on the debug host

     workstation. The text is then written to the stdout device (normally a

     shell window) of the gload process.



     In order to make osSyncPrintf more efficient it is suggested that an rdb

     output buffer be set up first by a call to osInitRdb. osSyncPrintf

     requires that the interrupt service handler be functional before it is

     used.  Consequently, osSyncPrintf should not be called from the boot

     thread.



     Because multiple threads can use the printing facility, it is possible

     for data to be mixed as threads swap in and out. Changes effective with

     release 2.0f cause osSyncPrintf to have significantly less impact on game

     performance. In the past, a call to osSyncPrintf would cause the

     interrupt processing and thread swapping to stop until all data had been

     transferred to the host Indy. This is no longer the case.



WARNING

     If large quantities of data are printed at once, it is possible to

     overflow the kernel printf buffers. When this happens the system will

     attempt to print a warning message to the console. If a continual stream

     of data is printed, it is possible to generate enough data to cause the

     Indy to spend all of its time servicing the interrupts associated with

     the osSyncPrintfs. When this happens it will appear as if the Indy is

     frozen, since interrupts have priority over processing user interaction.

     If the stream of osSyncPrintf can be stopped, the Indy should recover and

     resume normal functioning.





SEE ALSO

     sprintf(3S), osInitialize(3P), printf(3S),

























                                                                        Page 1







