





rgb2c(1P)                                                            rgb2c(1P)







NAME

     rgb2c - .rgb file converter to C data structure



SYNOPSIS

     rgb2c [-m name] [-f fmt] [-o output] [-s bits] [-t citype] [-l r,g,b] [-h

     r,g,b] [-F] [-P] [-Q] [-S smask] [-X] [-b] [-r] infile.rgb



DESCRIPTION

     rgb2c reads an SGI RGB image file and generates a C data structure to

     standard output.  The input image can have from 1 to 4 planes.  A 1 plane

     input file is assumed to be intensity only.  A 2 plane input file is

     assumed to be intensity/alpha.  A 3 plane input file is treated as RGB,

     and a 4 plane input file is treated as RGBA.



     The currently supported output formats are Intensity (4/8 bit),

     Intensity/Alpha (4/8/16 bit), and RGBA (16/32 bit).  Any other specified

     combination of type and bit size will be mapped to one of the above

     choices.



     Command line options are:



          -m name     Name of the C data structure.  Defaults to "texture".



          -f fmt      Specify the format of the output.  Choices are I, IA,

                      and RGBA.



          -o output   Specify format of output text.  Choices are C for .c

                      output, MIP for mip-mapped .c output, MIPSUPPLIED for

                      mip-mapped .c output with the different levels

                      supplied,, or RAW for raw ASCII format.  When using

                      MIPSUPPLIED the texture files should be named:

                      name0.rgb, name1.rgb, name2.rgb, etc where name0.rgb is

                      the top level image and each successive image is exactly

                      half the size (in x and y) of the preceding one.



          -s bits     Specifies the bit size of the output data. Choices are

                      4, 8, 16, 32.



          -t citype   Specifies the bit size of the output data. Choices are

                      4, 8, 16, 32.



          -l r,g,b    Specify the low colors for interpolation.  Defaults to

                      0, 0, 0.



          -h r,g,b    Specify the high colors for interpolation.  Defaults to

                      255, 255, 255.



          -F          Flip image verticially.



          -P          Toggle padding of texel rows for use with

                      gDPLoadBlock(3P).  (The default is padding on.)









                                                                        Page 1













rgb2c(1P)                                                            rgb2c(1P)







          -Q          Quadricate (replicate each entry four times) the lookup

                      table that is output for CI type textures.  This option

                      is used when loading TLUTs using the load_block command

                      (as is done for version 1 of the hardware).



          -S smask    Swap 32-bit words on odd lines, toggling bit smask in

                      texels.



          -X          Add extra padding to make all declared objects a

                      multiple of 32 bytes long.



          -b          Toggle shifting each tile by 0.5.  This is neccessary

                      when mip map levels are supplied (output type

                      MIPSUPPLIED) when the shift has been performed when the

                      lower levels were filtered.  Ususlly don't use this

                      option.



          -r          Don't include the raw data.  This can be used when the

                      output type is MIP or MIPSUPPLIED to avoid including

                      extraneous data which will eat memory space.  Do not use

                      this option with C output.



SEE ALSO

     flt2c(1P)































































                                                                        Page 2







