





rsp(1P)                                                                rsp(1P)







NAME

     rsp, rspg, rsp_ops - Ultra 64 signal processor (RSP) simulator





SYNOPSIS

     rsp [-vs] [script_file]

     rspg [-s] [script_file]

     rsp_ops



DESCRIPTION

     rsp is a simulator and debugger for the Ultra 64's Reality Signal

     Processor (RSP).  rsp can be run in text-mode (as rsp), in curses mode

     (as rsp -v), and with a graphics interface (as rspg).  rsp_ops is a

     utility program which dumps out the RSP opcode syntax.



     Command line options are:



          -v          Runs in curses mode.



          -s          Puts spaces every four digits of the vector display in

                      visual or graphics mode.



          script_file is an optional simulator script that can be invoked at

          start-up.





   Text Mode

     When the simulator is run, it starts up in a command mode. In this mode,

     the user can control the RSP. The command set is a combination of typical

     assembly-level debugging commands plus some more unusual ones to help

     control the RSP.



     Execution of the simulator can be stopped by typing 'Ctrl-C' (the

     processor will halt, leaving you in the debugger).



     Simply hitting RETURN at the rsp> prompt will execute the last command

     again. This is very handy for stepping through the execution.



     Commands can be abbreviated by their shortest unique string.



     The debugger commands are:





          ! <cmd>     Executes the shell command <cmd>.



          #           Any command beginning with a '#' is a comment, and will

                      just be echoed back to the screen. This is useful for

                      command source files and breakpoint-executed commands.



          append <file> <addr> <len>

                      Appends memory to a file.









                                                                        Page 1













rsp(1P)                                                                rsp(1P)







          bcopy <from> <to> <len>

                      This command copies memory around; <len> bytes from

                      <from> to <to>.  This comand is most useful to simulate

                      the "master" relationship of the host CPU, copying

                      memory into the IMem, etc.



          break [<addr>] [<clk>]

                      Set a breakpoint. Sets a breakpoint at the current PC

                      address, or at <addr>. If "clk" is specified, the value

                      of <addr> is interpreted as a clock time, and the

                      breakpoint will be set at that time.



          command <bp>

                      Add debugger commands to be executed when breakpoint

                      <bp> is hit. This is useful for printing out information

                      while debugging, etc. Remember that a debugger command

                      that starts with '#' is a comment, so you can echo any

                      text out this way. Enter the debugger commands, one per

                      line, and type 'end' when you are finished. If you want

                      to delete all the commands, just type 'end' as the first

                      command. Editing is limited, if you make a mistake,

                      you'll probably have to re-type it.



          cont        Continue execution, after stopping.



          dbase <addr>

                      Set base address of data window.



          deposit <addr> <value>

                      Puts <value> into the contents of the memory at <addr>.

                      The address is a word address, you can't specify

                      individual bytes. (you have to retype the bytes you

                      don't want to change...) Scalar registers can be

                      specified by typing $r as the <addr>, vector registers

                      can be specified by typing $vr as the <addr>. Symbolic

                      registers like pc, ctl, clk can also be given.



          disable <brkpt>

                      Disable the specified breakpoint. (Currently there is no

                      way to "delete" a breakpoint, other than disabling it).



          enable <brkpt>

                      Enable the specified breakpoint. Turns 'on' a previously

                      disabled breakpoint.



          evaluate <expr>

                      Evaluate an expression.



          examine <addr> [<count>]

                      Examine memory at <addr> for <count> bytes. Default

                      <count> is one word. Allows you to look at the memory.









                                                                        Page 2













rsp(1P)                                                                rsp(1P)







          file <file> View source file.



          help <command>

                      Prints a help screen. If <command> is given, prints a

                      more verbose message for that command.



          info        Prints out information about the debugger state, such as

                      current breakpoints.



          list <addr> [<count>]

                      List (disassemble) the program at <addr> for <count>

                      statements.  Default <count> is 10. A period "." can be

                      used to specify the PC.



          load <file> <addr>

                      Read bytes from <file> and copy them to memory beginning

                      at <addr>.  This command could be used to load up a task

                      list (program) to execute, or data to operate on.



          nosilent    Turns on verbose messages.



          quit        Exit simulator.



          register [<reg>]

                      Examine register <reg>, if specified, or all registers.

                      Also displays PC, CLK, and RSP CTL registers.



          run         Begin execution. Things are reset and the program begins

                      running.



          silent      Turns off some non-critical messages.



          source <srcfile>

                      Reads a file of rspsim commands, executing each one.

                      Useful for loading a program in a certain way and

                      setting up the RSP state during development.



          step [<count>]

                      Step execution <count> clock ticks. Default <count> is

                      one.



          symboltable <file>

                      Load symbol table.



          vregister [<reg>]

                      Examine vector register <reg>, if specified, or all

                      vector registers.  Also displays VAC, VCO, and VCC.



          vrint <reg> Examine integer vector register <reg> (inteprets data as

                      integers)











                                                                        Page 3













rsp(1P)                                                                rsp(1P)







          vrdouble <int_reg> <frac_reg>

                      Examine vector register pair as floating point numbers.



          vrfrac <reg>

                      Examine vector register <reg> (inteprets data as

                      fraction)



          texamine <addr> <type>

                      Look at a structure in memory.



          watch <addr>

                      Set a memory watchpoint. If this memory is "touched",

                      the processor will halt at the next clock cycle.



          write <file> <addr> <len>

                      Write out the contents of memory at <addr> for <len>

                      bytes to a file named <file>. This will be useful for

                      creating RDP command lists.







   Curses Mode

     [say something here about the curses version. Window size, etc....]





   Graphics Mode

     When rsp is run as rspg, the simulator is run with a graphics interface

     and five windows are opened.  The command input window accepts a line of

     input from the user.  All commands available in text mode are available

     here, plus a few outlined below.  The registers window displays the

     processor state in a similar way as the curses mode, with some

     enhancements.  The command output window displays what would have been

     printed in text mode.  The source window displays either the disassembled

     instructions of instruction memory, or the source code corresponding to

     the current symbol table (see the symboltable command).  Finally, the

     data window displays 4096 bytes of memory, which defaults to the on-chip

     data memory.



     Command Input Window

          The "command input" window accepts a line of input from the user.

          The mouse pointer does not have to be inside this window for the

          keystrokes to go there; it only needs to be in one of the windows of

          the debugger.  The right button (when in the "command input" window)

          brings up a menu of commonly used commands, and the middle button

          (in any window) repeats the previous command, as if the return key

          had been pressed on an empty input line.  A subset of the standard

          emacs key bindings are available.  The prefix "M-" in the table

          below corresponds to the "Alt" key:



                  ^A                    -> beginning-of-line

                  ^B                    -> backward-char

                  ^D                    -> delete-char-or-list







                                                                        Page 4













rsp(1P)                                                                rsp(1P)







                  ^E                  -> end-of-line

                  ^F                    -> forward-char

                  ^N                    -> down-history

                  ^P                    -> up-history

                  ^T                    -> transpose-chars

                  M-b                   -> backward-word

                  M-d                   -> delete-word

                  M-f                   -> forward-word



          Arrow keys also work, along with Ctrl-Leftarrow and Ctrl-Rightarrow

          to move by words.  A ten-command history is kept.



     Registers Window

          The "registers" window displays the current state of the Signal

          Processor.  This includes the 32 scalar and 32 vector registers, the

          special registers (e.g., the program counter), and some other

          internal state information.  Every time the program counter moves,

          the register window is redrawn and the changes in the window are

          highlighted in cyan.  If the .name directive was used in the source

          file and symbol information was loaded using the symboltable

          command, then the registers' names appear instead of the register

          numbers.  The -s command-line switch puts spaces every four digit in

          the vector display.



     Command Output Window

          This window displays the textual results of commands.  The scroll-

          back bar can be used to review the last hundred or so lines.

          Although this window has a green cursor, it does not accept input.



     Source Window

          The source window displays the running code.  If no symbol

          information is supplied, then all 1024 instructions of imem are

          disassembled, the line of the program counter is highlighted in

          green, and breakpoints are highlighted in red.  The scrollbar

          represents all 1024 instructions and green and red bars appear on

          that scale.  If symbolic information was supplied with the

          symboltable command, then the source code file is displayed.  Each

          time the program counter moves, the source window is updated to

          display the new location centered in the window.



          The right mouse button brings up a menu with several options.  The

          first toggles between "Silent" and "Verbose".  This option not only

          changes the state of the text output (see the silent and nosilent

          commands), but also disables and enables the updating of all of the

          windows in the middle of runs.  The second option toggles between

          disassembling the code and displaying the source file.  If in

          source-file mode, then remaining options allow the user to display

          the different files for which the debugger has symbol information.

          A "(PC)" is displayed next to the file in which the program counter

          is located.











                                                                        Page 5













rsp(1P)                                                                rsp(1P)







          Clicking on a line with the left mouse button places a breakpoint on

          that line.  Clicking on a line which already has a breakpoint

          toggles it between enabled and disabled; disabled breakpoints are

          highlighted in dark red.



     Data Window

          The data window always displays 4096 bytes of memory.  Although it

          defaults to displaying the data memory in the Signal Processor, the

          dbase command can be used to change the starting address.  The right

          mouse button brings up a menu with which the display mode can be

          selected.  The choices are hexadecimal, signed decimal, unsigned

          decimal, and vector format.  The last choice is useful when

          displaying data which is in the graphics vector format.  The data

          window can be split or cloned.  The new window is independent of the

          old one, although currently all data windows must have the same base

          address (as set by the dbase command).  Closing all data windows

          quits the application.





NOTE

     Be careful of blank lines in scripts, particularly ones initiated at

     start-up. Since a RETURN executes the last command, blank lines can cause

     unintended behavior.





SEE ALSO

     rspasm(1P)

























































                                                                        Page 6







