





vadpcm_enc(1P)                                                  vadpcm_enc(1P)







NAME

     vadpcm_enc - ADPCM encoder for Ultra 64 audio



SYNOPSIS

     vadpcm_enc -c codebook [-t] [-l minLoopLength] aifcFile codedFile



DESCRIPTION

     vadpcm_enc encodes AIFC or AIFF sound files and produces a compressed

     binary file which which is used by the Ultra 64 audio library. The

     encoding algorithm is based on a switched ADPCM algorithm which uses a

     codebook to define a table of prediction coefficients. Coefficients from

     the table are selected adaptively during encoding to give the best sound

     quality.  The Ultra 64 compressed sound format currently supports a

     single loop point which should be defined in the input file's Instrument

     Chunk.  The codebook and loop point definitions are embedded in the final

     output file.



     Command line options are:



          -c <filename>

                      Defines a file which contains the prediction coefficient

                      codebook constructed by tabledesign(1).



          -t          Truncate the encoded file after the loop end point. The

                      portion of the sound after the loop end point is never

                      used in audio playback.



          -l <value>  Set the minimum loop length in the encoded file (see

                      Note below).



NOTE

     There is a restriction in the audio library which means that in a single

     call to alAudioFrame(1P) a sound must only pass through two loop

     crossings.  To ensure less than two loop crossings the ADPCM encoder can

     `stretch' loops by repeating them. The currently defined default minimum

     loop length is 1600 samples. This default length can be changed (see

     above).  Loops shorter than the minimum loop length will be repeated

     until the total loop length is larger than the minimum length. In a given

     application the required minimum loop length depends on the number of

     samples requested in a single call to alAudioFrame(1P) and the maximum

     pitch shift incurred by the samples. For further information see Chapter

     14 of the developers manual.



SEE ALSO

     tabledesign(1P), vadpcm_dec(1P)





















                                                                        Page 1







