





gSPLight(3P)                                                      gSPLight(3P)







NAME

     gSPLight, gsSPLight - load a light into the RSP.



C SPECIFICATION

     #include "gbi.h"



     typedef struct {

       unsigned char col[3];   /* diffuse light value (rgba)               */

       char          pad1;

       unsigned char colc[3];  /* copy of diffuse light value (rgba)       */

       char          pad2;

       signed char   dir[3];   /* direction TOWARDS the light source       */

       char          pad3;     /* This does not need to be normalized      */

     } Light_t;                /* but should have a large magnitude (~127) */



     typedef union {

         Light_t     l;

         long int    force_structure_alignment[4];

     } Light;





     gSPLight(Gfx *gdl, Light *l, int n)



     gsSPLight(Light *l, int n)





PARAMETERS

     *gdl      graphics display list pointer.



     l         light pointer.



     n         number of the light to replace, 1-8.



     The gSPLight (3P) command loads a single light structure into the

     numbered position in the light buffer.



     Use the gSPNumLights (3P) command to specify which lights should be used

     in the lighting calculation.  If gSPNumLights (3P) specifies that N

     lights will be used, then the 1st N lights (1-N) will be used as

     directional lights (color and direction) and the N+1st will be used as an

     ambient light (color only).



     The colors in the light structure combine the color of the light with the

     color of the material. Although this convention may seem awkward at

     first, this optimization provides significant speedup in the RSP geometry

     engine.



     After the light is set (with a gSPLight (3P) command) and then used (with

     any gSPVertex (3P) command) then that light's color may be changed for

     vertices in future gSPVertex (3P) calls by calling gSPLight (3P) again.

     This method of changing the light color is performance-efficient (note

     that this is also the method to use for changing the material color).







                                                                        Page 1













gSPLight(3P)                                                      gSPLight(3P)







     However, if the light's direction must be changed, then the light must be

     resent with a gSPLight (3P) command AND the number of lights must be

     reset (even if it has not changed) with a gSPNumLights (3P) command.



     The best way to define static lights is to use the gdSPDefLights (3P)

     command followed by the gSPSetLights (3P) command (instead of using

     gSPLight(3P) and gSPNumLights(3P) explicitly).



NOTE

     Requiring a copy of the diffuse light value in the structure is an

     optimization for the RSP geometry engine; lighting calculations for

     vertices are processed two at a time. This optimization could be

     exploited for 'special effects'.





SEE ALSO

     gSPGeometryMode(3P) gSPSetLights(3P) gdSPDefLights(3P) gSPNumLights(3P)

     gSPLightColor(3P)











































































                                                                        Page 2







